if(!eu) var eu={};
if(!eu.galaxytool) eu.galaxytool={};
if(!eu.galaxytool.GTPlugin_galaxyview) eu.galaxytool.GTPlugin_galaxyview={};


eu.galaxytool.GTPlugin_galaxyview = {
	
	selectedGalaxy: -1,
	selectedSystem: -1,
	
	
	get_galaxyview_data: function(docroot) {
	    var rows;
	    var cells;
	    var galaxyview = new Array(15);
	    var galaxy_content;
	
	    var moonsize;
	    var metal_debris;
	    var crystal_debris;
	    var planetname;
		var player_rank;
		var alliance_rank;
		var alliance_member;
		var alliance_id;
	    var position = 0;
	    var colonized_planets = 0;
	    var destroyed_planets = 0;
	    var galaxy_xml = "";

		
	    try {
			rows = docroot.getElementById('galaxytable').rows;
	       	found = 1;
	    } catch(e) {
	        eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+1 , 0, "Unexpected error: no galaxy table found");
	        return false;
	        // nothing to do
	    }
		
		try {
		    for(var i = 2; i < rows.length; i++) {
		    	if (rows[i].getAttributeNode("class").value == "row") {
			        cells = rows[i].cells;
			
			        // reset data
			        position = 0;
			        moonsize = 0;
			        metal_debris = 0;
			        crystal_debris = 0;
			        playerid = 0;
			        playerstatus = "";
			        playername = "";
			        planetname = "";
			        alliance = "";
			        player_rank = 0;
			        alliance_rank = 0;
			        alliance_member = 0;
			        alliance_id = 0;
				        		
					// planet position
					position = cells[1].innerHTML;
			        galaxy_content = position+"|";
			
					// planetname
					try {
						// free planets or planets in phalanx have a hyperlink
						planetname = cells[3].getElementsByTagName("a")[0].innerHTML;
						// <img width="12" height="12" src="img/icons/phalanx-icon.gif" alt=""/> is behind planet names
						if (planetname.indexOf("<") > 0) {
							planetname = planetname.substring(0,planetname.indexOf("<"));
						}
						var tmp = cells[3].innerHTML; // phalanx planets have a link with &page=phalanx
						if (tmp.indexOf("page=phalanx") == -1) {
							planetname = "";
						}
					} catch(no_error) {
						
						try {
							// there are two possibilities for span-tags:
							// 1. it shows the time when a player was last active (its class is "undermark")
							// 2. there is a popup inside, when there is not enough Deuterium to get a phalanx
							if (cells[3].getElementsByTagName("span")[0].getAttribute("class") == "undermark") {
								planetname = cells[3].innerHTML;
							} else {
								planetname = cells[3].getElementsByTagName("span")[0].innerHTML;
								planetname = planetname.substring(0,planetname.indexOf("<img"));
							}
						} catch (no_error2) {
							// planets viewed from a planet have no hyperlink
							// and no popup-info about missing Deuterium, so no span-tag
							planetname = cells[3].innerHTML;
						}
					}
					
					// activity is shown in ()
					if (planetname.indexOf("(") > 0) {
						planetname = planetname.substring(0,planetname.indexOf("("));
					}
	
					// remove any | inside planetnames (workaround only)
					planetname = eu.galaxytool.GTPlugin_general.trimString(planetname);
			        galaxy_content += planetname.replace(/\|/g,"")+"|";
			
					// moonsize
					try {
					    if (cells[4].getElementsByTagName("img")[0].getAttribute("src").indexOf("moon_c.gif") > -1) {
					        moonsize = 0;
					    } else {
					       	try {
								var tmp = cells[4].getElementsByTagName("li")[2].getElementsByTagName("span")[0].innerHTML;
								// inner html: 4998 km
								tmp = tmp.replace(/[^0-9]/g,"");
								moonsize = parseInt(tmp);
							} catch(no_error) {
									// the moon, from which you are watching this system
									// send -1, needs v4.5.4 to work properly, before that version, moons are deleted
									moonsize = 1;
							}
						}
					} catch(no_moon) {
						//no image
						moonsize = 0;
					}
		
			        galaxy_content += moonsize+"|";
					
					// debris metal + crystal
					try {
						var tmp = cells[6].getElementsByTagName("ul")[1].getElementsByTagName("li")[0].innerHTML; // metal
						
						//some debris-field have 4.500,5 for example; as we expect int-values here, delete everything behind the last ,
						//Taiwan OGame has 4,500 as DF !
						//maybe, we should change this in a later version of Galaxytool to float
						tmp = eu.galaxytool.GTPlugin_general.trimString(tmp);
						tmp = tmp.replace(/,\d$/,"");
												
						tmp = tmp.replace(/[^0-9]/g,"");
						
						metal_debris = parseInt(tmp);
					} catch(no_error) {
						metal_debris = 0;
					}
		
					try {
						var tmp = cells[6].getElementsByTagName("ul")[1].getElementsByTagName("li")[1].innerHTML; // crystal
						
						// remove ,5
						tmp = eu.galaxytool.GTPlugin_general.trimString(tmp);
						tmp = tmp.replace(/,\d$/,"");
						
						tmp = tmp.replace(/[^0-9]/g,"");
						
						crystal_debris = parseInt(tmp);
					} catch(no_error) {
						crystal_debris = 0;
					}
					
			        galaxy_content += metal_debris+"|";
			        galaxy_content += crystal_debris+"|";
			        		
					// playername
					try {
						playername = cells[7].getElementsByTagName("a")[0].getElementsByTagName("span")[0].innerHTML;
					} catch(no_error) {
						// no player or own player
						try {
							playername = cells[7].getElementsByTagName("span")[0].innerHTML;
						} catch(no_error2) {
							playername = "";	
						}
					}
					playername = eu.galaxytool.GTPlugin_general.trimString(playername);
					if (playername != "") {
						colonized_planets++;
					} else if (planetname != "") {
						destroyed_planets++;
					}
					// Col: remove |
					galaxy_content += playername.replace(/\|/g, "")+"|";
					
					// player status - transfer the english letters for them
					// example HTML code: <td class="playername vacation longinactive banned strong noob">
					var tmp = cells[7].getAttributeNode("class").value;
					if (tmp.indexOf("vacation") > -1) {
						playerstatus += "v";
					}
					if (tmp.indexOf("longinactive") > -1) {
						playerstatus += "iI";
					}
					if (tmp.indexOf("inactive") > -1) {
						playerstatus += "i";
					}
					if (tmp.indexOf("banned") > -1) {
						playerstatus += "b";
					}
					if (tmp.indexOf("strong") > -1) {
						playerstatus += "s";
					}			
					if (tmp.indexOf("noob") > -1) {
						playerstatus += "n";
					}			
			        galaxy_content += playerstatus+"|";
					
					// ally tag
					// with workaround because no closing tags
					// <span class="allytagwrapper TTgalaxy" rel="#alliance6">GER<div id="alliance6" style="display: none;">
					// <span class="allytagwrapper TTgalaxy" rel="#alliance79">TEAM FR<div id="alliance79" style="display: none;">
					alliance = cells[9].innerHTML;
					
					alliance = alliance.substring(alliance.indexOf(">")+1);
					alliance = alliance.substring(0,alliance.indexOf("<"));
					
					// Col: remove |
			        galaxy_content += alliance.replace(/\|/g, "")+"|";
			        


					// player id
					if (playername != "") {
						try {
							var tmp = cells[7].getElementsByTagName("a")[0].getAttributeNode("rel").value; // rel="#player100446"
							tmp = tmp.replace(/[^0-9]/g,"");
							playerid = parseInt(tmp);
						} catch(no_error) {
							// own player
							playerid = 0;
						}
					}
			        galaxy_content += playerid+"|";
					
					// player rank
					if (playername != "") {
						try {
							var tmp = cells[7].getElementsByTagName("li")[0].innerHTML;
							var rank_test = /-/;
							if(rank_test.test(tmp)) {
								tmp = "0";
							}
							tmp = tmp.replace(/[^0-9]/g,"");
							player_rank = parseInt(tmp);
						} catch(no_error) {
							// own player
							try {
								player_rank = docroot.getElementById("bar").getElementsByTagName("li")[2].innerHTML.match(/\((\d+)\)/)[1];
							} catch(arabic_ogame) {
								//right to left ogame
								player_rank = docroot.getElementById("bar").getElementsByTagName("li")[3].innerHTML.match(/\((\d+)\)/)[1];
							}
						}				
					}

			        galaxy_content += player_rank+"|";
					
			        //ally id
			        try {
			        	alliance_id = cells[9].getElementsByTagName("span")[0].getAttributeNode("rel").value;
			        	alliance_id = parseInt(alliance_id.replace(/[^0-9]/g,""));
			        } catch (no_ally) {
			        	alliance_id = 0; 
			        }
					
					// ally rank + member
					if (alliance != "") {
						var tmp = cells[9].getElementsByTagName("li")[0].innerHTML;
						tmp = tmp.replace(/[^0-9]/g,"");
						alliance_rank = parseInt(tmp);
						
						var tmp = cells[9].getElementsByTagName("li")[1].innerHTML;
						tmp = tmp.replace(/[^0-9]/g,"");
						alliance_member = parseInt(tmp);
					
					}
			        galaxy_content += alliance_rank+"|";
			        galaxy_content += alliance_member+"|";
				        
			        // delete all \n within this string
			        galaxy_content = galaxy_content.replace(/\n+/,"");
			        if (position < 16) {
			        	// do not collect position 16 here (if displayed)
				        galaxyview[i] = galaxy_content;
			        }
					
					// some validity checks
					// remember: 10th planet = planetname + status but nothing else (no error)
					// destroyed planet = planetname only
					if ((playername == "" && moonsize > 0) || 
						(playername == "" && playerid > 0) ||
						(playername == "" && alliance != "") ||
						(playername == "" && alliance_member > 0) ||
						(playername == "" && alliance_rank > 0)) { 
						/* ||
						(planetname == "" && moonsize > 0) ||
						(planetname == "" && playerid > 0) ||
						(planetname == "" && playerstatus != "") ||
						(planetname == "" && alliance != "") ||
						(planetname == "" && alliance_member > 0) ||
						(planetname == "" && alliance_rank > 0)) {
						*/
						
						eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+1 , 0, "Inconsistent data found (other extensions may change ogame source code so that no data can be found). "
						+ "position: "+position + "\n" +
						+ "planetname: "+planetname + "\n" +
						+ "moonsize: "+moonsize + "\n" +
						+ "playername: "+playername + "\n" +
						+ "playerid: "+playerid + "\n" +
						+ "playerstatus: "+playerstatus + "\n" +
						+ "alliance: "+alliance + "\n" +
						+ "alliance member: "+alliance_member + "\n" +
						+ "alliance rank: "+alliance_rank + "\n");
								
						return [false,false];
						// inconsistent data
						
					}
					
					if(galaxy_xml == "") {
						galaxy_xml += '	<galaxyview galaxy="'+this.getGalaxy(docroot)+'" system="'+this.getSystem(docroot)+'">'+'\n';
					}
					
					//create xml for the current position
					if (playername == "" && metal_debris == 0 && crystal_debris == 0) {
						//complete empty position
		    			galaxy_xml += '		<position pos="'+position+'"/>'+'\n';
		    		} else if (playername == "" && (metal_debris != 0 || crystal_debris != 0)) {
		    			// only DF in case the planet is destroyed
		    			galaxy_xml += '		<position pos="'+position+'">'+'\n';
		    			galaxy_xml += '			<debris metal="'+metal_debris+'" crystal="'+crystal_debris+'"/>'+'\n';
		    			galaxy_xml += '		</position>'+'\n';
		    		} else {
		    			//complete entry
		    			galaxy_xml += '		<position pos="'+position+'">'+'\n';
			    		
			    		if (planetname != "") {
			    			galaxy_xml += '			<planetname>'+planetname+'</planetname>'+'\n';
			    		}
			    		if (moonsize != 0) {
			    			galaxy_xml += '			<moon size="'+moonsize+'"/>'+'\n';
			    		}
			    		if (metal_debris > 0 || crystal_debris > 0) {
			    			galaxy_xml += '			<debris metal="'+metal_debris+'" crystal="'+crystal_debris+'"/>'+'\n';
			    		}
						if (playername != "") {
							galaxy_xml += '			<player playername="'+playername+'" rank="'+player_rank+'" playerid="'+playerid+'"';
								if( playerstatus != "") {
									galaxy_xml += ' status="'+playerstatus+'"';
								}
							galaxy_xml += '/>'+'\n';
						}
					 	if(alliance != "") {
						 	galaxy_xml += '			<alliance allyname="'+alliance+'" allyid="'+alliance_id+
						 				  '" rank="'+alliance_rank+'" member="'+alliance_member+'"/>'+'\n';
						}
						
						galaxy_xml += '		</position>'+'\n';
		    		}
		    		
		    	} // if (rows[i].getAttributeNode("class").value == "row") { .. }

		    } 
			
			galaxy_xml += '	</galaxyview>'+'\n';
			
			// for(var i = 2; i < rows.length; i++) { .. }
			// check number of planets with planets that are populated
			// try {
				// var temp = docroot.getElementById("colonized").innerHTML;
			 	// temp = temp.match(/(\d+)/)[1];
				// if (colonized_planets + destroyed_planets != temp) {
					// eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+1 , 0, "Number of detected planets ("+ (colonized_planets + destroyed_planets) +") does not match the number of planets ogame provides ("+temp+")");
					// return false;
				// }
			
			// } catch(e2) {
				// eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+1 , 0, "Unexpected error: ID 'colonized' not found at galaxy view: "+e2);	
			// }
		
			// "solar system" name to be compatible with old galaxytool version
		    var galaxystring = "solar system " + galaxyview.join("\n");
		    return [galaxystring,galaxy_xml];
		} catch(error) {
	    	// unexpected error
	    	eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+1 , 0, "Unexpected error: "+error);
	    	return [false,false];
	    }
	},
	

	getGalaxy: function(docroot) {
	    // get information about what galaxy selected
	    try {
			return parseInt(docroot.getElementsByName("galaxy")[0].value);
	
	    } catch (e){
	    	eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 0, eu.galaxytool.GTPlugin_general.getLocString("error.gvnotupdated"));
	        return -1;
	    }
	},
	
	getSystem: function(docroot) {
	    // get information about what system selected
	    try {
			return parseInt(docroot.getElementsByName("system")[0].value);
	
	    } catch (e){
	    	eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 0, eu.galaxytool.GTPlugin_general.getLocString("error.gvnotupdated"));
	        return -1;
	    }
	},
	
	
	submit_galaxydata: function(e) {
			try {
				if (e.target.innerHTML.indexOf('id="galaxyheadbg2"') == -1) {
					// something else was added to the galaxyview, but not the view itself
					return;
				}
			} catch(e) {
				// something else was added to the galaxyview, but not the view itself
				return;
			}
			// now we found HTML content that contained the ID
			
			
			
			doc = eu.galaxytool.GTPlugin_general.Messagedoc;
			

			// reset status window content from any previous transmission
			try {
				eu.galaxytool.GTPlugin_general.clear_status(doc);
			} catch(e) {
				alert("error: "+e);
			}
	
	        eu.galaxytool.GTPlugin_general.selectedGalaxy = this.selectedGalaxy = this.getGalaxy(doc);
	        eu.galaxytool.GTPlugin_general.selectedSystem = this.selectedSystem = this.getSystem(doc);
			eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 0, eu.galaxytool.GTPlugin_general.getLocString("galaxyfound.prefix")+this.selectedGalaxy+":"+this.selectedSystem+eu.galaxytool.GTPlugin_general.getLocString("galaxyfound.suffix"));
	        var text,text_xml;
	        [text,text_xml] = this.get_galaxyview_data(doc);
	        
	        //alert(text_xml);
	        
			if (text != false) var GTPlugin_result = eu.galaxytool.GTPlugin_general.send(doc,"galaxy",text,text_xml,doc.location.href);
	}	
}	
