if(!eu) var eu={};
if(!eu.galaxytool) eu.galaxytool={};
if(!eu.galaxytool.GTPlugin_general) eu.galaxytool.GTPlugin_general={};

eu.galaxytool.GTPlugin_general = {

	Prefs: null,
	selectedTyp: -1,
	selectedWer: -1,
	selectedGalaxy: -1,
	selectedSystem: -1,
	selectedRanks: -1,
	Messagedoc: null,
	debug_mode: false,
	version: "2.4",


	getLocString: function(string) {
		try {
		    var locString = document.getElementById( "gtStrings" ).getString( "gt_" + string );
		
		    locString = locString.replace(/^[.]/, '');
		    locString = locString.replace(/[.]$/, '');
		    return locString;
		} catch(e) {
			alert("unexpected error at getLocString for string: "+string+"\nerror: "+e);
			return "";
		}
	},
	
	getPrefs: function() {
	    return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	},
	
	openOptionsDialog: function() {
	    var windowobject = window.openDialog("chrome://galaxyplugin/content/galaxyoptions2.xul", "options", "chrome");
	},
	
	getUniverse: function(docroot) {
	    // return universe
	    var title = docroot.getElementsByTagName("title")[0].innerHTML;
	    try {
		    var tmp = title.match(/(\d+)/)[1];
		    tmp = parseInt(tmp);
		    return tmp;
	    } catch(no_error) {
	    	// character universe name
	    	return title;
	    }
	},
	
	trimString: function(string) {
	    // Return empty if nothing was passed in
	    if (!string) return "";
	
	    // Efficiently replace any leading or trailing whitespace
	    var value = string.replace(/^\s+/, '');
	    value = value.replace(/\s+$/, '');
	
	    // Replace any multiple whitespace characters with a single space
	    value = value.replace(/\s+/g, ' ');
	
	    // Return the altered string
	    return value;
	},

	get_language: function(url) {
		var tmp = url;
	
		try {
			// remove http:// and www
			tmp = tmp.replace(/http\:\/\//, "");
			tmp = tmp.replace(/https\:\/\//, "");
			tmp = tmp.replace(/www\./, "");
			
			// remove all behind the first /
			var pos = tmp.indexOf("/");
			tmp = tmp.substring(0,pos);
			
			// remove first part in front of . (uni1.ogame.org)
			pos = tmp.indexOf(".");
			tmp = tmp.substring(pos+1);
			
			// remove ogame. and o-game.
			tmp = tmp.replace(/ogame\./, "");
			tmp = tmp.replace(/o\-game\./, "");
			
		    return tmp;
		} catch(e) {
			// alert("error at eu.galaxytool.GTPlugin_general.get_language: "+e);
			return false;
		}	
	},
	
	create_status_tab: function(docroot) {
	    try {
	    	var my_div;
	    	var main_div;
	        var my_table; // = docroot.createElement("<table>");
	        var my_row;
	        var my_td;
	        var my_attribute;
	        var needsExtraCSS = (docroot.location.href.toString().search("page=globalTechtree") > -1 
	        					|| docroot.location.href.toString().search("page=empire") > -1
	        					|| docroot.location.href.toString().search("page=showmessage") > -1);
	        
	        // check if we are on techtree or empire view or single message view (missing css files)
		    try {
		    	url_prefix = "../";
		    	if (needsExtraCSS) {
		    		url_prefix = "";

		    		var missing_styles = docroot.createElement("style");
			        my_attribute = docroot.createAttribute("type");
			        my_attribute.nodeValue = "text/css";
			        missing_styles.setAttributeNode(my_attribute);
			        missing_styles.innerHTML = "\n"+ 
			        ".content-box-s .content {\n"+
				    "background:url("+url_prefix+"img/navigation/box_1_mitte.gif) repeat-y;\n"+
				    "padding:0px 15px;\n"+
    				"color:#f1f1f1;\n"+
    				"font: 100 12px Verdana, Arial, SunSans-Regular, Sans-Serif;\n"+
					"border: 0 none;\n"+
					"margin: 0;\n"+		
					"}\n"+
					
					".content-box-s .header {\n"+
					"background:url("+url_prefix+"img/navigation/box_1_kopf.gif) no-repeat;\n"+ 
				    "height:32px;\n"+
				    "font-size:11px;\n"+
				    "text-transform:uppercase;\n"+
    				"color:#f1f1f1;\n"+
    				"font: 100 11px Verdana, Arial, SunSans-Regular, Sans-Serif;\n"+
					"border: 0 none;\n"+
					"margin: 0;\n"+		
					"padding: 0;\n"+
					"width: 222px;\n"+
					"float: none;\n"+	
					"}\n"+
					
					".content-box-s .footer {\n"+
					"background:url("+url_prefix+"img/navigation/box_1_fuss.gif) no-repeat;\n"+
					"height:21px;\n"+
    				"color:#f1f1f1;\n"+
    				"font: 100 11px Verdana, Arial, SunSans-Regular, Sans-Serif;\n"+
					"border: 0 none;\n"+
					"margin: 0;\n"+		
					"padding: 0;\n"+		
					"}\n"+
					
					"div.content-box-s .header h3 {\n"+
					"color:#6F9FC8;\n"+
					"font-size:11px;\n"+
					"font-weight:700;\n"+
					"padding-top:11px;\n"+
					"width:222px;\n"+
					"text-align:center;\n"+
					"background:none;\n"+
					"height:13px;\n"+
					"overflow:visible;\n"+
					"line-height:13px;\n"+
					"}\n"+

					"a.close_details {\n"+
					"height:16px;\n"+
					"width:16px;\n"+
					"float: left; \n"+
					"margin-top: 2px; \n"+
					"margin-left: 5px;\n"+
					"}\n"+
					"a.close_details:link,\n"+
					"a.close_details:visited { background:transparent url("+url_prefix+"img/layout/detail-spriteset.gif) -207px 0px no-repeat;}\n"+
					"a.close_details:hover { background:transparent url("+url_prefix+"img/layout/detail-spriteset.gif) -207px -17px no-repeat;}\n"+
					"a.close_details:active,\n"+
					"a.close_details:focus {background:transparent url("+url_prefix+"img/layout/detail-spriteset.gif) -207px 0px no-repeat;}\n"+
					
					".content-box-s .table {\n"+
					"border: 0 none;\n"+
					"}\n"+
					
					".content-box-s .td {\n"+
					"border: 0 none;\n"+
					"padding: 0;\n"+
					"}\n"
					;
		    		docroot.getElementsByTagName("head")[0].appendChild(missing_styles);
		    		//docroot.getElementById("empireTab").appendChild(missing_styles);
		    	}	
		    } catch(e) {
		        // nothing to do
		    }	        
	        
	
			// <script type="text/javascript" src="chrome://galaxyplugin/content/ogame_window.js"></script>
			var my_script = docroot.createElement("script");
	        my_attribute = docroot.createAttribute("type");
	        my_attribute.nodeValue = "text/javascript";
	        my_script.setAttributeNode(my_attribute);
	        my_attribute = docroot.createAttribute("src");
	        my_attribute.nodeValue = "chrome://galaxyplugin/content/ogame_window.js";
	        my_script.setAttributeNode(my_attribute);
			docroot.getElementsByTagName("body")[0].appendChild(my_script);
	
	
			main_div = docroot.createElement("div");
	        my_attribute = docroot.createAttribute("class");
	        my_attribute.nodeValue = "content-box-s"; // ogame CSS class - 222 px width - padding 15px
	        main_div.setAttributeNode(my_attribute);
	        my_attribute = docroot.createAttribute("style");
	        
	        try {
		        if (eu.galaxytool.GTPlugin_general.Prefs.getBoolPref("gtplugin.settings.show_statuswindow") == true) {
		        	my_attribute.nodeValue = "display: block;z-index: 999;"+eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.status_style_window"); // display block must be kept
		        } else {
		        	my_attribute.nodeValue = "display: none;z-index: 999;"+eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.status_style_window"); // display block must be kept
		        }
	        } catch(not_set) {
	       	// didn't open options dialogue once!
	        	alert("You haven't configured the Galaxytoolbar, yet");
	        	return;
	        }
	        main_div.setAttributeNode(my_attribute);
	        my_attribute = docroot.createAttribute("id");
	        my_attribute.nodeValue = "galaxytool_status";
	        main_div.setAttributeNode(my_attribute);
	        //Omar Hawk: these functions are nowhere defined, so I commented them out
		        //my_attribute = docroot.createAttribute("onclick");
		        //my_attribute.nodeValue = "GTPLUGIN_mouse_released()";
		        //main_div.setAttributeNode(my_attribute);
		        //my_attribute = docroot.createAttribute("onmousedown");
		        //my_attribute.nodeValue = "GTPLUGIN_mouse_pressed()";
		        //main_div.setAttributeNode(my_attribute);
	        
	        my_div = docroot.createElement("div");
	        my_attribute = docroot.createAttribute("class");
	        my_attribute.nodeValue = "header"; // ogame CSS class
	        my_div.setAttributeNode(my_attribute);        
	
	        var my_link = docroot.createElement("a");
	        my_attribute = docroot.createAttribute("class");
	        my_attribute.nodeValue = "close_details"; // ogame CSS class for close button
	        my_link.setAttributeNode(my_attribute);        
	        my_attribute = docroot.createAttribute("style");
	        my_attribute.nodeValue = "float: right; margin: 5px;";
	        my_link.setAttributeNode(my_attribute);        
	        my_attribute = docroot.createAttribute("onclick");
	        my_attribute.nodeValue = "document.getElementById('galaxytool_status').style.display = 'none';";
	        my_link.setAttributeNode(my_attribute);
	        my_attribute = docroot.createAttribute("href");
	        my_attribute.nodeValue = "#";
	        my_link.setAttributeNode(my_attribute);
	        my_div.appendChild(my_link);
			var my_h3 = docroot.createElement("h3");
	        my_attribute = docroot.createAttribute("style");
	        my_attribute.nodeValue = eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.status_style_header");
			my_h3.setAttributeNode(my_attribute);        
			var myText = document.createTextNode(eu.galaxytool.GTPlugin_general.getLocString("status_window"));
			my_h3.appendChild(myText);
	        my_div.appendChild(my_h3);
	        
			// my_div.innerHTML = eu.galaxytool.GTPlugin_general.getLocString("status_window");
	        main_div.appendChild(my_div);
	        
	        my_div = docroot.createElement("div");
	        my_attribute = docroot.createAttribute("class");
	        my_attribute.nodeValue = "content"; // ogame CSS class
	        my_div.setAttributeNode(my_attribute);
	        my_attribute = docroot.createAttribute("style");
	        my_attribute.nodeValue = "max-height:200px; max-width: 190px; overflow: auto;"; // additional stuff for content pane
	        my_div.setAttributeNode(my_attribute);
	        main_div.appendChild(my_div);
	        
	        var my_table = my_div.appendChild(docroot.createElement("table"));
	        if (needsExtraCSS) {
		        my_attribute = docroot.createAttribute("class");
		        my_attribute.nodeValue = "content-box-s table"; // might not exist in all cases (defined on top of this method)
		        my_table.setAttributeNode(my_attribute);
	        }
			// cellpadding + spacing = 0
	        my_attribute = docroot.createAttribute("style");
	        my_attribute.nodeValue = "width: 192px;";
	        my_table.setAttributeNode(my_attribute);
	        my_attribute = docroot.createAttribute("border");
	        my_attribute.nodeValue = "0";
	        my_table.setAttributeNode(my_attribute);
	        my_attribute = docroot.createAttribute("cellpadding");
	        my_attribute.nodeValue = "0";
	        my_table.setAttributeNode(my_attribute);
	        my_attribute = docroot.createAttribute("cellspacing");
	        my_attribute.nodeValue = "0";
	        my_table.setAttributeNode(my_attribute);
	        my_attribute = docroot.createAttribute("align");
	        my_attribute.nodeValue = "center";
	        my_table.setAttributeNode(my_attribute);
			// results for all galaxytools
			var number_of_rows = eu.galaxytool.GTPlugin_storage.get_number_of_tools();
			if (number_of_rows < 1) number_of_rows = 5; // fallback
	        for (var i=1; i <= number_of_rows; i++) {
	            my_row = my_table.appendChild(docroot.createElement("tr"));
	            my_td = my_row.appendChild(docroot.createElement("td"));
	            my_attribute = docroot.createAttribute("id");
	            my_attribute.nodeValue = "galaxyplugin"+i;
	            my_td.setAttributeNode(my_attribute);
	            if (needsExtraCSS) {
		            my_attribute = docroot.createAttribute("class");
		            my_attribute.nodeValue = "content-box-s td";
		            my_td.setAttributeNode(my_attribute);
	            }
	            my_attribute = docroot.createAttribute("style");
	            my_attribute.nodeValue = "text-align:left; display: none; z-index: 999;"+eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.status_style_results"); // Display none must be kept
	            my_td.setAttributeNode(my_attribute);
	
	            var myText = document.createTextNode(" ");
	            my_td.appendChild(myText);
	
	        }
	        my_div = docroot.createElement("div");
	        my_attribute = docroot.createAttribute("class");
	        my_attribute.nodeValue = "footer"; // ogame CSS class
	        my_div.setAttributeNode(my_attribute);
	        main_div.appendChild(my_div);
	                
	        docroot.getElementsByTagName("body")[0].appendChild(main_div);
	        
	    } catch(e) {
	    	alert("Error at create_status_tab: "+e);
	    }
	},
	
	clear_status: function(docroot) {
		try {
			var tmp = docroot.getElementById("galaxytool_status");
			if (tmp == null) {
				// we did not yet create our status tab, so we have nothing to do
				return;
			}
			var number_of_rows = eu.galaxytool.GTPlugin_storage.get_number_of_tools();
			if (number_of_rows < 1) number_of_rows = 5; // fallback
			for (var i=1; i<=number_of_rows; i++) {
				docroot.getElementById("galaxyplugin"+i).innerHTML = '';
			}
		} catch(error) {
			alert("unexpected error at eu.galaxytool.GTPlugin_general.clear_status: "+error);
		}
	},
	
	set_status: function(docroot, html_id , status, text) {
		try {
			var tmp = docroot.getElementById("galaxytool_status");
			if (tmp == null) {
				// we did not yet create our status tab
				this.create_status_tab(docroot);
			} else {
				// just in case the window was hidden meanwhile
				// check if it should be hidden
				if (eu.galaxytool.GTPlugin_general.Prefs.getBoolPref("gtplugin.settings.show_statuswindow") == true) {
					docroot.getElementById("galaxytool_status").style.display = "block";
				} else {
					// keep window hidden in case it was no error
					if (status == 3) {
						docroot.getElementById("galaxytool_status").style.display = "block";
					}					
				}
			}
			
		} catch(error) {
			alert("unexpected error at eu.galaxytool.GTPlugin_general.set_status: "+error);
		}
		
	    try {
	    	var picture;
	        switch (status) {
	        	case 0:
	            picture = "";
	        	break;
	            case 1:
	            picture = "<img src=\"chrome://galaxyplugin/skin/images/green.png\" width=\"10px\" height=\"10px\">&nbsp;&nbsp;";
	            break;
	            case 2:
	            picture = "<img src=\"chrome://galaxyplugin/skin/images/yellow.png\" width=\"10px\" height=\"10px\">&nbsp;&nbsp;";
	            break;
	            case 3:
	            picture = "<img src=\"chrome://galaxyplugin/skin/images/red.png\" width=\"10px\" height=\"10px\">&nbsp;&nbsp;";
	            break;
	        }
	        if (this.debug_mode == true) {
	        	// newline and add new line
	        	docroot.getElementById(html_id).innerHTML += "<br>"+picture+text;
	        } else {
	        	// replace current content
	        	docroot.getElementById(html_id).innerHTML = picture+text;	
	        }
	        docroot.getElementById(html_id).style.display = "block";
	    } catch(e) {
	        // alert("Error at set_status: "+e);
	    }
	},
	
	submit_galaxytool_version: function(galaxytool_url) {

		var major = 0;
		var minor = 0;
		var revision = 0;
		var version;
	 	try {
			var param = 'type=validate';
			var httpRequest = new XMLHttpRequest();
			httpRequest.open("POST", galaxytool_url, true);
			httpRequest.setRequestHeader("Content-Type","application/x-www-form-urlencoded;charset=UTF-8");
			httpRequest.overrideMimeType("text/xml");
			httpRequest.onreadystatechange = function () {
		       if (httpRequest.readyState == 4) {
		        	 if (httpRequest.status == 200) {
		        	 	try {
		        	 		//alert(httpRequest.responseText);
			        	 	version = httpRequest.responseXML.getElementsByTagName("version")[0];
							
			        	 	major = parseInt(version.getAttribute("major"));
	
			        	 	if (version.hasAttribute("minor")) {
			        	 		minor = parseInt(version.getAttribute("minor"));
			        	 	}
			        	 	
			        	 	if (version.hasAttribute("revision")) {
			        	 		revision = parseInt(version.getAttribute("revision"));
			        	 	}
			        	 	
			        	 	eu.galaxytool.GTPlugin_storage.update_galaxytool_version(galaxytool_url,major,minor,revision); 	
		        	 	} catch(invalid_xml_or_old_tool) {
		        	 		//nothing to do
		        	 	}	
		        	 }
		        }
			}
		       
		    httpRequest.send(param);
	 	} catch(error) {
	 		alert("error: "+error);
	 	}
	 	
	},

		
	sendData: function(docroot,type,text,text_xml,content_type_xml,target_url,url_params,
						toolnumber,universe,tool_version_major,tool_version_minor,tool_version_revision) {
		try {
	        var responsetext = "";
	        var error_messages = "";
	        /*
	        //create xml-doc out of string
			var parser = new DOMParser();  
   			var xml_doc = parser.parseFromString(text_xml);
	       		
			//create string out of DOM-tree
			var serializer = new XMLSerializer();
			var xml_string = serializer.serializeToString(xml_doc);
			*/
			
	        this.submit_galaxytool_version(target_url);
	        
			// Status Codes:
			// - 200 = generally okay
			// - 403 = forbidden
			// - Response Text:
			// - 601: galaxy view inserted
			// - 602: problem with inserting galaxy view
			// - 611: report inserted
			// - 612: at least one report was wrong
			// - 621: stats updated
			// - 622: stats not updated
			// - 631: allyhistory updated
			// - 632: allyhistory not updated
			// - 700: no content
			// - 701: wrong universe
			// - 702: toolbar outdated
			// - 703: invalid XML
	        if(this.compare_versions(tool_version_major,tool_version_minor,tool_version_revision,4,6,0)) {
		       if (content_type_xml == "player_stats") {
		            responsetext = eu.galaxytool.GTPlugin_general.getLocString("statsupdated.playerprefix");
		            if (this.selectedTyp == 0) responsetext = responsetext + eu.galaxytool.GTPlugin_general.getLocString("statsupdated.scoreinfix")+this.selectedRanks+eu.galaxytool.GTPlugin_general.getLocString("statsupdated.suffix");
		            if (this.selectedTyp == 1) responsetext = responsetext + eu.galaxytool.GTPlugin_general.getLocString("statsupdated.fleetinfix")+this.selectedRanks+eu.galaxytool.GTPlugin_general.getLocString("statsupdated.suffix");
		            if (this.selectedTyp == 2) responsetext = responsetext + eu.galaxytool.GTPlugin_general.getLocString("statsupdated.researchinfix")+this.selectedRanks+eu.galaxytool.GTPlugin_general.getLocString("statsupdated.suffix");
		        } else {
		        	if (content_type_xml == "ally_stats"){
		        		responsetext = eu.galaxytool.GTPlugin_general.getLocString("statsupdated.allyprefix");
		        		if (this.selectedTyp == 0) responsetext = responsetext + eu.galaxytool.GTPlugin_general.getLocString("statsupdated.scoreinfix")+this.selectedRanks+eu.galaxytool.GTPlugin_general.getLocString("statsupdated.suffix");
		            	if (this.selectedTyp == 1) responsetext = responsetext + eu.galaxytool.GTPlugin_general.getLocString("statsupdated.fleetinfix")+this.selectedRanks+eu.galaxytool.GTPlugin_general.getLocString("statsupdated.suffix");
		            	if (this.selectedTyp == 2) responsetext = responsetext + eu.galaxytool.GTPlugin_general.getLocString("statsupdated.researchinfix")+this.selectedRanks+eu.galaxytool.GTPlugin_general.getLocString("statsupdated.suffix");
		        	}
		        }
		
		        if (content_type_xml == "galaxyview") {
		            responsetext = eu.galaxytool.GTPlugin_general.getLocString("galaxyupdated.prefix")+this.selectedGalaxy+":"+this.selectedSystem+eu.galaxytool.GTPlugin_general.getLocString("galaxyupdated.suffix");
		        }
		
		        if (content_type_xml == "reports" || content_type_xml == "planetinfo") {
		            responsetext = eu.galaxytool.GTPlugin_general.getLocString("reportsupdated");
		        }
		        if (content_type_xml == "allypage") {
		            responsetext = eu.galaxytool.GTPlugin_general.getLocString("allyhistoryupdated");
		        }
	        	
	        	
	        	if (this.debug_mode == true) {
		        	this.set_status(docroot, "galaxyplugin"+toolnumber , 0, "Target URL:"+target_url);
					this.set_status(docroot, "galaxyplugin"+toolnumber , 0, 'Data to send:<br><pre style="color: white; font-size:7pt;">'
									+text_xml.replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\"/g,"&quot;")+'</pre>');
	        	}
	        	
				var params ='type='+content_type_xml+'&content='+text_xml;
				var httpRequest = new XMLHttpRequest();
	        	httpRequest.open("POST", target_url, true);
	       		httpRequest.setRequestHeader("Content-Type","application/x-www-form-urlencoded;charset=UTF-8");
	        	//httpRequest.setRequestHeader("Content-Length", params.length);
	        	httpRequest.overrideMimeType("text/xml");
	        	httpRequest.onreadystatechange = function () {
	        	 	if (httpRequest.readyState == 4) {
	        	 		if (httpRequest.status == 200) {
	        	 			try {
	        	 				//alert(httpRequest.responseText);
		        	 			var gtool_result = httpRequest.responseXML;
								var returncode = parseInt(gtool_result.getElementsByTagName("returncode")[0].childNodes[0].nodeValue);
	        	 			} catch(error) {
	        	 				var returncode = 0;
	        	 			}
	        	 		}
	        	 		var debug_mode = eu.galaxytool.GTPlugin_general.debug_mode; 
	        	 		
	        	 		if (debug_mode == true) {
							eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "HTTP Request Status Code: "+httpRequest.status);
	        	 		}
	        	 		
		        	 	if (httpRequest.status == 403) { // forbidden
		                    eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.permissiondenied"));
		                    return 0;
		                } else if (httpRequest.status == 404) { // Server responsed
		                    eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.pagenotfound"));
		                    return 0;
		                } else if (httpRequest.status == 200) { // Server responsed
		                    if ((returncode == 601) || (returncode == 611) || (returncode == 621) || (returncode == 631)) { // gv updated
				                eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 1, responsetext);
		                        return 1;
		                    } else
		                    
		                    error_messages = eu.galaxytool.GTPlugin_general.get_messages(gtool_result);
		                    
		                    if (error_messages == "") error_messages = "none";
		                    
		                    if (returncode == 602) { // gv not updated
		                        if (debug_mode == true) eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "Details:<br>"+error_messages);
		                        eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.gvnotupdated"));
		                        return 0;
		                    } else if (returncode == 612) { // at least 1 report not inserted
		                    	if (debug_mode == true) eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "Details:<br>"+error_messages);
		                        eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.reporterror"));
		                        return 0;
		                    } else if (returncode == 622) { // stats not updated
		                    	if (debug_mode == true) eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "Details:<br>"+error_messages);
		                        eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.statserror"));
		                        return 0;
		                    } else if (returncode == 632) { // allyhistory not updated
		                    	if (debug_mode == true) eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "Details:<br>"+error_messages);
		                        eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.allyhistoryerror"));
		                        return 0;
		                    } else if (returncode == 700) { // no content
		                    	if (debug_mode == true) eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "Details:<br>"+error_messages);
		                    	eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, "no content");
		                        return 0;
		                    } else if (returncode == 701) { // wrong universe
		                    	if (debug_mode == true) eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "Details:<br>"+error_messages);
		                    	eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.wrong_universe"));
		                        return 0;
		                    } else if (returncode == 702) { // toolbar outdated
		                    	if (debug_mode == true) eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "Details:<br>"+error_messages);
		                    	eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.toolbar_outdated"));
		                        return 0;
		                    } else if (returncode == 703) { //Invalid XML
		                    	if (debug_mode == true) eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "Details:<br>"+error_messages);
		                    	eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, "Invalid XML");
		                        return 0;	                    	
		                    } else {
		                    	if (debug_mode == true) eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "Details:<br>"+error_messages);
		                        eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.unknown"));
		                        return 0;
		                    }
		                } else {
		                	eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, eu.galaxytool.GTPlugin_general.getLocString("error.badstatuscode")+httpRequest.status);
		                    return 0;
		                }
	        	 	}
	        	 }
	        	 httpRequest.send(params); 
	        	 
	        	 
	        	 
	        } else {
	        
	        if (type == "stats") {
	            url_params = url_params + "&who="+this.selectedWer+"&what="+this.selectedTyp;
	            if (this.selectedWer == 0) responsetext = eu.galaxytool.GTPlugin_general.getLocString("statsupdated.playerprefix");
	            if (this.selectedWer == 1) responsetext = eu.galaxytool.GTPlugin_general.getLocString("statsupdated.allyprefix");
	            if (this.selectedTyp == 0) responsetext = responsetext + eu.galaxytool.GTPlugin_general.getLocString("statsupdated.scoreinfix")+this.selectedRanks+eu.galaxytool.GTPlugin_general.getLocString("statsupdated.suffix");
	            if (this.selectedTyp == 1) responsetext = responsetext + eu.galaxytool.GTPlugin_general.getLocString("statsupdated.fleetinfix")+this.selectedRanks+eu.galaxytool.GTPlugin_general.getLocString("statsupdated.suffix");
	            if (this.selectedTyp == 2) responsetext = responsetext + eu.galaxytool.GTPlugin_general.getLocString("statsupdated.researchinfix")+this.selectedRanks+eu.galaxytool.GTPlugin_general.getLocString("statsupdated.suffix");
	        }
	
	        if (type == "galaxy") {
	            url_params = url_params + "&galaxy="+this.selectedGalaxy+"&system="+this.selectedSystem;
	            responsetext = eu.galaxytool.GTPlugin_general.getLocString("galaxyupdated.prefix")+this.selectedGalaxy+":"+this.selectedSystem+eu.galaxytool.GTPlugin_general.getLocString("galaxyupdated.suffix");
	        }
	
	        if (type == "reports" || type == "fleet" || type == "defense" || type == "buildings" || type == "techs") {
	            responsetext = eu.galaxytool.GTPlugin_general.getLocString("reportsupdated");
	        }
	        if (type == "allyhistory") {
	            responsetext = eu.galaxytool.GTPlugin_general.getLocString("allyhistoryupdated");
	        }
	        url_params = url_params + "&uni=" + universe + "&toolbar=" + this.version;
	
			if (this.debug_mode == true) {
	            url_params = url_params + "&debug=true";
	            this.set_status(docroot, "galaxyplugin"+toolnumber , 0, "Target URL:"+target_url);
				this.set_status(docroot, "galaxyplugin"+toolnumber , 0, "Data to send:<br>"+text);
				this.set_status(docroot, "galaxyplugin"+toolnumber , 0, "URL parameter:<br>"+url_params);
			} else {
				url_params = url_params + "&debug=false";
			}
			// add content after printing debug info
			url_params = url_params + "&content=" + encodeURIComponent(text); // needed to send data with special chars like \s or \n
	
	        var httpRequest = new XMLHttpRequest();
	        httpRequest.open("POST", target_url, true); // 3. Parameter ist für asynchronen Transfer nötig
	        httpRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	        httpRequest.setRequestHeader("Content-Length", url_params.length);
	        // httpRequest.send(url_params);
	        httpRequest.onreadystatechange = function () {
	            if (httpRequest.readyState == 4) {
					eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "HTTP Request Status Code: "+httpRequest.status);
					if (httpRequest.status == 200) { // page returned

						var gtool_result = httpRequest.responseText.match(/\<div id=\"galaxytool_result\"\>\S{3}\<\/div\>/);
	
						if (gtool_result) {
							// new galaxytool result
							gtool_result = gtool_result[0].substring(28,gtool_result[0].length - 6);
						} else {
							// old galaxytool
							gtool_result = parseInt(httpRequest.responseText);
							if (gtool_result == NaN) {
								gtool_result = 0;
								eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "HTTP Returntext: "+httpRequest.responseText);							
							}
							
						}
					}

					if (eu.galaxytool.GTPlugin_general.debug_mode == true) {
						eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "HTTP Request Status Code: "+httpRequest.status);
						// new galaxytool result
						eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "HTTP Request Response:<br>"+gtool_result);
						// extract debug content
						var gtool_debug = httpRequest.responseText.match(/\<div id=\"galaxytool_debug\"\>.+\<!\-\- debug ende \-\-\>\<\/div\>/);
						if (gtool_debug) {
							gtool_debug = gtool_debug[0].substring(27,gtool_debug[0].length - 25);
							eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, "HTTP Request Debug:<br>"+gtool_debug);
						}
					}
				
	                if (httpRequest.status == 403) { // forbidden
	                    eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.permissiondenied"));
	                    return 0;
	                } else if (httpRequest.status == 404) { // Server responsed
	                    eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.pagenotfound"));
	                    return 0;
	                } else if (httpRequest.status == 200) { // Server responsed
	                    if ((gtool_result == 601) || (gtool_result == 611) || (gtool_result == 621) || (gtool_result == 631)) { // gv updated
			                eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 1, responsetext);
	
	                        return 1;
	                    } else if (gtool_result == 602) { // gv not updated
	                        eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.gvnotupdated"));
	                        return 0;
	                    } else if (gtool_result == 612) { // at least 1 report not inserted
	                        eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.reporterror"));
	                        return 0;
	                    } else if (gtool_result == 622) { // stats not updated
	                        eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.statserror"));
	                        return 0;
	                    } else if (gtool_result == 632) { // allyhistory not updated
	                        eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.allyhistoryerror"));
	                        return 0;
	                    } else if (gtool_result == 700) { // no content
	                    	eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, "no content");
	                        return 0;
	                    } else if (gtool_result == 701) { // wrong universe
	                    	eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.wrong_universe"));
	                        return 0;
	                    } else if (gtool_result == 702) { // toolbar outdated
	                    	eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.toolbar_outdated"));
	                        return 0;
	                    } else {
	                        eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 3, eu.galaxytool.GTPlugin_general.getLocString("error.unknown"));
	                        return 0;
	                    }
	                } else {
	                	eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+toolnumber , 0, eu.galaxytool.GTPlugin_general.getLocString("error.badstatuscode")+httpRequest.status);
	                    return 0;
	                }
	
	            }
	        };
	        
	        httpRequest.send(url_params); //function above will then be called
	        }
	    } catch(e) {
	    	this.set_status(docroot, "galaxyplugin"+toolnumber , 0, eu.galaxytool.GTPlugin_general.getLocString("error.gtserveronotfound"));
	        return 0;
	    }
	    return 0;
		
	},
	
	get_messages: function(xml_doc) {
		var output = "";
		try {
			var messages = xml_doc.getElementsByTagName("message");
			var tabs = "";
			
			for (var i = 0; i < messages.length; i++) {
				for (j = 1; j < parseInt(messages[i].getAttribute("depth")); j++) {
					tabs += "	";
				}
				output += '<pre style="color: red; font-size:7pt;">'+tabs+messages[i].childNodes[0].nodeValue.replace(/\n/g,'\n'+tabs)+'</pre>';
				tabs = "";
			}
			
		} catch (no_messages) {
			// nothing to do
		}
		return output;
	},	
	
	send: function(docroot,type,text,text_xml,source_url) {
	    var url_params  = "";
	    var url_params2 = "";
	    var target_url  = "";
	    var sent        = false;
	    var universe    = 0;
	    var tool_version_major   = 0;
	    var tool_version_minor   = 0;
	    var tool_version_revision = 0;
	    
	    var language = eu.galaxytool.GTPlugin_general.get_language(docroot.location.href.toString());
	    var xml_language = this.get_language_for_xml(language);

		try {
			var current_tool_number = 0;
			var tools = eu.galaxytool.GTPlugin_storage.read_tools_for_ogame_url(source_url);
			
			for (i=0; i < tools.length; i++) {
				// check if the information shall be sent or not 
				if ((type == "fleet"       && tools[i]["submit_fleet"]     == false) ||
				    (type == "defense"     && tools[i]["submit_defense"]   == false) ||
				    (type == "buildings"   && tools[i]["submit_buildings"] == false) ||
				    (type == "techs"       && tools[i]["submit_research"]  == false) ||
				    (type == "galaxy"      && tools[i]["submit_galaxy"]    == false) ||
				    (type == "stats"       && tools[i]["submit_stats"]     == false) ||
				    (type == "reports"     && tools[i]["submit_reports"]   == false) ||
				    (type == "allyhistory" && tools[i]["submit_allypage"]  == false) ) {

					continue;
				}
				
				current_tool_number++;	
		
			    if (type == "fleet" || type == "defense" || type == "buildings" || type == "techs") {
			    	language = "org"; // those information are now sent as language EN only regardless of the real language
				    var planetname,coords,moon_or_planet;
				    [planetname,coords,moon_or_planet] = eu.galaxytool.GTPlugin_planet_data.getPlanetname(docroot);
				    var metal = eu.galaxytool.GTPlugin_planet_data.get_resources(docroot,"resources_metal");
				    var crystal = eu.galaxytool.GTPlugin_planet_data.get_resources(docroot,"resources_crystal");
				    var deut = eu.galaxytool.GTPlugin_planet_data.get_resources(docroot,"resources_deuterium");
				    var energy = eu.galaxytool.GTPlugin_planet_data.get_resources(docroot,"resources_energy");
				    url_params2 = "&planet="+planetname+" "+coords+"&metal="+metal+"&crystal="+crystal+"&deut="+deut+"&energy="+energy+"&moon_or_planet="+moon_or_planet;
			    }
				
	            url_params = "user="+tools[i]["tool_user"]+"&password="+tools[i]["tool_password"]+"&typ="+type;
	            url_params = url_params + url_params2 + "&language="+language;
	            target_url  = tools[i]["tool_url"];
	            
	   
	            var content_type;
	            var xs_def;
	            var xs_def_end;
	            
	            switch(type) {
	            	case "galaxy": 
	            		content_type 	= 'galaxyview';
	            		xs_def		= '<galaxyviews xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+
	            				  	  ' xsi:noNamespaceSchemaLocation="galaxyview.xsd">'+'\n';
	            		xs_def_end 	= '</galaxyviews>';
	            		 break;
	            	case "fleet": 
	            		content_type  = "planetinfo"; 
	            		xs_def		= '<planetinfos xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+
	            						' xsi:noNamespaceSchemaLocation="planetinfo.xsd">'+'\n';
	            		xs_def_end	= '</planetinfos>';
	            		break;
	            	case "buildings": 
	            		content_type  = "planetinfo"; 
	            		xs_def		= '<planetinfos xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+
	            					  ' xsi:noNamespaceSchemaLocation="planetinfo.xsd">'+'\n';
	            		xs_def_end	= '</planetinfos>';
	            		break;
	            	case "defense": 
	            		content_type  = "planetinfo"; 
	            		xs_def		= '<planetinfos xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+
	            					  ' xsi:noNamespaceSchemaLocation="planetinfo.xsd">'+'\n';
	            		xs_def_end	= '</planetinfos>';
	            		break;
	            	case "techs": 
	            		content_type  = "planetinfo"; 
	            		xs_def		= '<planetinfos xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+
	            					  ' xsi:noNamespaceSchemaLocation="planetinfo.xsd">'+'\n';
	            		xs_def_end	= '</planetinfos>';
	            		break;
	            	case "stats": 
	            		if (this.selectedWer == 0) {
			           		content_type = "player_stats";
			           	} else {
			           		content_type = "ally_stats";
			           	}
			           	xs_def		 = '<stats xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+
			           				   ' xsi:noNamespaceSchemaLocation="stats.xsd">'+'\n';
			           	xs_def_end	 = '</stats>';
			           	break;
	           		case "allyhistory": 
	           			content_type	 = "allypage"; 
	           			xs_def		 = '<allypage xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+
	           						   ' xsi:noNamespaceSchemaLocation="allypage.xsd">'+'\n';
	           			xs_def_end	 = '</allypage>';
	           			break;
	           		case "reports":
	           			content_type	 = "reports";
	           			xs_def		 = '<reports xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+
	           						   ' xsi:noNamespaceSchemaLocation="reports.xsd">'+'\n';
	           			xs_def_end	 = '</reports>';
	           			break;
	            } 

	           //after this, the xml-string is ready to be sent
	           var xml = '<?xml version="1.0" encoding="UTF-8"?>'+'\n'
	           			+xs_def
	           			+'	<header version="'+this.version+'" universe="'+tools[i]["universe"]
	           			+'" debug="'+this.debug_mode+'" language="'+xml_language+'" username="'+tools[i]["tool_user"]
	           			+'" password="'+this.get_MD5(tools[i]["tool_password"])+'" content_type="'+content_type+'"/>'+'\n'
	           			+text_xml
	           			+xs_def_end;
	          
	
	            universe     		 = tools[i]["universe"];
	            tool_version_major   = tools[i]["tool_version_major"];
	            tool_version_minor   = tools[i]["tool_version_minor"];
	            tool_version_revision= tools[i]["tool_version_revision"];
	            
	            this.sendData(docroot,type,text,xml,content_type,target_url,url_params,current_tool_number,universe,tool_version_major,tool_version_minor,tool_version_revision);
	            sent = true;
			}

	        if ( sent == false ) {
	        	this.set_status(docroot, "galaxyplugin"+1 , 0, eu.galaxytool.GTPlugin_general.getLocString("error.unknownuni"));
	            return 0;
	        }
	
	    } catch(e) {
	    	this.set_status(docroot, "galaxyplugin"+1 , 3, eu.galaxytool.GTPlugin_general.getLocString("error.gtserveronotfound"));
	        return 0;
	    }
	    return 1;
	},
	
	get_language_for_xml: function(tld) {
		var language = "";
		switch (tld) {
			case "com.es" 	: language = "spanish"; break;
			case "it"     	: language = "italian"; break;
			case "com.pt" 	: language = "portugues"; break;
			case "org"   	: language = "english"; break;
			case "us"   	: language = "english"; break;
			case "de"    	: language = "german"; break;
			case "nl"     	: language = "dutch"; break;
			case "ru"     	: language = "russian"; break;
			case "com.br" 	: language = "brazilian"; break;			
			case "ba.org" 	: language = "balkan"; break;
			case "com.hr" 	: language = "croatian"; break;
			case "fr"     	: language = "french"; break;
			case "pl"		: language = "polish"; break;
			case "tr.org" 	: language = "turkish"; break;
			case "dk"     	: language = "danish"; break;
			case "se"     	: language = "swedish"; break;
			case "gr"     	: language = "greek"; break;
			case "ro"     	: language = "romanian"; break;
			case "hu"     	: language = "hungarian"; break;
			case "cz"     	: language = "czech"; break;
			case "no"     	: language = "norwegian"; break;
			case "tw"     	: language = "taiwan"; break;
			case "jp"     	: language = "japan"; break;
			case "bg.org" 	: language = "bulgarian"; break;
			case "lt"     	: language = "lithuanian"; break;
			case "lv"     	: language = "latvian"; break;
			case "fi"     	: language = "finnish"; break;
			case "sk"     	: language = "slovak"; break;
			case "rs"     	: language = "serbian"; break;
			case "com.cn" 	: language = "chinese"; break;
			case "cn"     	: language = "chinese"; break;			
			case "co.kr"  	: language = "korean"; break;
			case "kr"     	: language = "korean"; break;
			default: language = "english"; break;
		}
			

		return language;
	},
	
	get_MD5: function(string) {
		//https://developer.mozilla.org/en/nsICryptoHash#Computing_the_Hash_of_a_String
		var converter =
		  Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
		    createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
		
		converter.charset = "UTF-8";
		
		// result is an out parameter,
		// result.value will contain the array length
		var result = {};
		// data is an array of bytes
		var data = converter.convertToByteArray(string, result);
		var ch = Components.classes["@mozilla.org/security/hash;1"]
		                   .createInstance(Components.interfaces.nsICryptoHash);
		ch.init(ch.MD5);
		ch.update(data, data.length);
		var hash = ch.finish(false);
		
		// return the two-digit hexadecimal code for a byte
		function toHexString(charCode)
		{
		  return ("0" + charCode.toString(16)).slice(-2);
		}
		
		// no error here, though eclipse shows a syntax error
		// convert the binary hash data to a hex string.
		var s = [toHexString(hash.charCodeAt(i)) for (i in hash)].join("");
		// s now contains your hash in hex: should be
		
		return s;
	},
	
	/**
	 * returns: if version (first three values) is greater than or equal to version2
	 */
	compare_versions: function(major,minor,revision,major2,minor2,revision2) {
		return (major > major2) || 
			   ((major == major2) && (minor > minor2)) || 
			   ((major == major2) && (minor == minor2) && (revision >= revision2));
	},
	
	update_check: function() {
    	// check if update is needed - also run SQLite updates here!
    	var old_version;
    	try {
    		old_version = eu.galaxytool.GTPlugin_general.Prefs.getCharPref("gtplugin.settings.version");
    	} catch(pref_not_found) {
    		//was not installed yet
			eu.galaxytool.GTPlugin_general.Prefs.setCharPref("gtplugin.settings.version", decodeURIComponent(this.version));
			return;  		
    	}
    	
    	//alert('"'+old_version+'" :'+(old_version<"2.4"));
    	if (this.version != old_version) {
    		// execute update
    		if (old_version < "2.2") {
    			// set new pref. at 2.2 (new ogame version)
				eu.galaxytool.GTPlugin_general.Prefs.setCharPref("gtplugin.status_style_window", decodeURIComponent("position:fixed;top:10px;left:10px;z-index: 999;"));
				eu.galaxytool.GTPlugin_general.Prefs.setCharPref("gtplugin.status_style_header", decodeURIComponent("font-weight:bold;"));
				eu.galaxytool.GTPlugin_general.Prefs.setCharPref("gtplugin.status_style_results", decodeURIComponent("color:white;"));
    		}
    		
    		if (old_version < "2.3") {
    			// copy pref settings to DB
    			eu.galaxytool.GTPlugin_storage.copy_pref_data_to_db();
    			eu.galaxytool.GTPlugin_general.Prefs.setCharPref("gtplugin.settings.version", decodeURIComponent(this.version));
    			// the sqlite was created before, so no need to alter the tables once again (with update 2.4) -> return
    			return;
    		}
    		
    		if (old_version < "2.4") {
    			eu.galaxytool.GTPlugin_storage.install_update_2_4();
    		}
    		
    		eu.galaxytool.GTPlugin_general.Prefs.setCharPref("gtplugin.settings.version", decodeURIComponent(this.version));
    	}
	},
	
	log_to_console: function(text) {
		try {
			
			var My_ConsoleService =
			      Components.
			          classes['@mozilla.org/consoleservice;1'].
			              getService(Components.interfaces.nsIConsoleService);
			
			My_ConsoleService.logStringMessage('Galaxytool extension: ' + text);
			
		} catch(error) {
			alert("log to console: "+error);
		}
	},
	

	
}
