if(!eu) var eu={};
if(!eu.galaxytool) eu.galaxytool={};
if(!eu.galaxytool.GTPlugin_planet_data) eu.galaxytool.GTPlugin_planet_data={};


eu.galaxytool.GTPlugin_planet_data = {
	
	get_resources: function(docroot,element_id) {
		if(element_id == "resources_energy") return this.getPlanetEnergy(docroot);
		// this is more efficient than reading the tooltip
	    try {
	    	var temp = docroot.getElementById(element_id).innerHTML;
	    	temp = temp.replace(/\.|\,/g,""); // remove decimal comma/point
	    	// check if "K" or "M" is inside
	    	temp = temp.slice(temp.search(/(\d)+[KM]*/));
	    	if (temp.indexOf("K") > -1) {
				temp = parseInt(temp) * 1000;    		
	    	} else if (temp.indexOf("M") > -1) {
	    		temp = parseInt(temp) * 1000000;
	    	} else {
	    		temp = parseInt(temp);
	    	}
	    	return temp;
	    	
	    } catch(e) {
	   		// no chance to find resources
	   		return 0;
	   	}
	},
	
	getPlanetEnergy: function(docroot) {
	    try {
	        var temp = docroot.getElementById("energy_box").getAttribute("title");
	        // .5 / ,5 Energy is possible :/
	        //|<B>Energy:</B> <br><span class=''>403</span><br><span class=''>(7.764/8.166.5)</span>
	        temp = temp.match(/\(\S+\/(\S+)\)/)[1]; // => 8.166.5
	        
	        temp = temp.match(/[1-9]{1,3}([,.][0-9]{3})*/)[0]; // find the value without the last .5/,5 => 8.166

	        temp = temp.replace(/[^0-9]/g,""); // remove comma or decimal point => 8166
	        return parseInt(temp);
	    } catch(e) {
			return 0;
	    }
	},

	getPlanetname: function(docroot) {
	    // return currently selected planet: Array of [planetname,coordinates,moon_or_planet]
	    var i;
	    var planet_div;
	    var planetname = "";
	    var coordinates = "";
	    var planet_count = 0;
	    var moon_or_planet = "";
	    
	    try {
	    	// alert("planetname: "+planetname); 
	    	var main_div = docroot.getElementById("rechts");
	    	var tmp = docroot.getElementById("countColonies").getElementsByTagName("span")[0].innerHTML;
	    	planet_count = parseInt(tmp.match(/(\d+).+/)[1]);
	    	
	    	i = 3;
	    	while (planet_div = main_div.getElementsByTagName("div")[i]) {
	    		try {
		    		var classnames = planet_div.getElementsByTagName("a")[0].getAttributeNode("class").value;
		    		if ((classnames.search("planetlink") > -1) && ((classnames.search("active") > -1) || (planet_count == 1))) {
		    			// we found the active planet
		    			// var planetname = docroot.getElementById("header_text").getElementsByTagName("h2")[0].innerHTML;
		    			// var tmp = planetname.indexOf("-");
		    			// planetname = planetname.substring(tmp+1);
		    			if (planet_div.getElementsByTagName("a")[0].getAttribute("href") == "#") {
							// the selected planet has a "#" as href
							moon_or_planet = "planet";
						} else {
							// if a moon is selcted, the href is not a "#"
							moon_or_planet = "moon";
						}
						
		    			planetname = docroot.getElementById("selectedPlanetName").innerHTML;
		    			coordinates = planet_div.getElementsByTagName("span")[1].innerHTML;
						return [planetname,coordinates,moon_or_planet];
						
						    			
		    		}
	    		} catch(ignore_me) {
	    			// ignore me because not each A tag has a class attribute
	    		}
	    		i++;
	    	}
	   		// TODO: no planet found
	   		alert("no planet found");
	   		return "";
	   		
	    } catch(e) {
	        return "";
	    }
	},
	
	getEnglishNameForID: function(id) {
		switch (id) {
			// buildings
			case 1:    return "Metal Mine";
			case 2:    return "Crystal Mine";
			case 3:    return "Deuterium Synthesizer";
			case 4:    return "Solar Plant";
			case 12:   return "Fusion Reactor";
			case 212:  return "Solar Satellite";
			case 22:   return "Metal Storage";
			case 23:   return "Crystal Storage";
			case 24:   return "Deuterium Tank";
			// facilities
			case 14:   return "Robotics Factory";
			case 21:   return "Shipyard";
			case 31:   return "Research Lab";
			case 34:   return "Alliance Depot";
			case 44:   return "Missile Silo";
			case 15:   return "Nanite Factory";
			case 33:   return "Terraformer";
			// techs
			case 113:   return "Energy Technology";
			case 120:   return "Laser Technology";
			case 121:   return "Ion Technology";
			case 114:   return "Hyperspace Technology";
			case 122:   return "Plasma Technology";
			case 115:   return "Combustion Drive";
			case 117:   return "Impulse Drive";
			case 118:   return "Hyperspace Drive";
			case 106:   return "Espionage Technology";
			case 108:   return "Computer Technology";
			case 124:   return "Astrophysics";
			case 123:   return "Intergalactic Research Network";
			case 199:   return "Graviton Technology";
			case 111:   return "Armour Technology";
			case 109:   return "Weapons Technology";
			case 110:   return "Shielding Technology";
			// ships
			case 204:   return "Light Fighter";
			case 205:   return "Heavy Fighter";
			case 206:   return "Cruiser";
			case 207:   return "Battleship";
			case 215:   return "Battlecruiser";
			case 211:   return "Bomber";
			case 213:   return "Destroyer";
			case 214:   return "Deathstar";
			case 202:   return "Small Cargo";
			case 203:   return "Large Cargo";
			case 208:   return "Colony Ship";
			case 209:   return "Recycler";
			case 210:   return "Espionage Probe";
			case 212:   return "Solar Satellite";
			// defense
			case 401:   return "Rocket Launcher";
			case 402:   return "Light Laser";
			case 403:   return "Heavy Laser";
			case 404:   return "Gauss Cannon";
			case 405:   return "Ion Cannon";
			case 406:   return "Plasma Turret";
			case 407:   return "Small Shield Dome";
			case 408:   return "Large Shield Dome";
			case 502:   return "Anti-Ballistic Missiles";
			case 503:   return "Interplanetary Missiles";
			// moon
			case 41:    return "Lunar Base";
			case 42:    return "Sensor Phalanx";
			case 43:    return "Jump Gate";			
			
			default: 
			alert("Unknown entry "+ id +" found.");
			return false;
		}
	},
	
	translate_techids_to_english: function(tech_id_array) {
		translation = new Array();
		
		for (var i = 0; i < tech_id_array.length; i++) {
			translation.push(this.getEnglishNameForID(tech_id_array[i]));
		}

		return translation;
		
	},
	
	get_ressources_names: function(docroot) {
		var english_names = new Array("Metal","Crystal","Deuterium","Energy");
		var translated_names = new Array();
		//|<B>Metall:</B> <br><span class='overmark'>17.893.896/100.000</span><br><span class=''>(0)</span>
		translated_names.push(docroot.getElementById("metal_box").getAttributeNode("title").value.match(/\|<B>(.+)<\/B>/)[1]);
		translated_names.push(docroot.getElementById("crystal_box").getAttributeNode("title").value.match(/\|<B>(.+)<\/B>/)[1]);
		translated_names.push(docroot.getElementById("deuterium_box").getAttributeNode("title").value.match(/\|<B>(.+)<\/B>/)[1]);
		translated_names.push(docroot.getElementById("energy_box").getAttributeNode("title").value.match(/\|<B>(.+)<\/B>/)[1]);
		
		var tool_ids = eu.galaxytool.GTPlugin_storage.read_tool_ids_for_ogame_url(docroot.location.href);

		if(tool_ids.length > 0) {
			return eu.galaxytool.GTPlugin_storage.insert_ressources_names(tool_ids,english_names,translated_names);
		}
	},
	
	getData: function(docroot,param_name,previous_data,return_string) {
	    var i = 0;
	    var j = 0;
	    var k = 0;
	    var entry;
	    
	    

		var entries = docroot.getElementById(param_name).getElementsByTagName("li");

	    
	
	    var name = new Array(entries.length-1);
	    var amount = new Array(entries.length-1);
	
	    try {
	    	for (i = 0; i < entries.length; i++) {
	    		// now we have one entry of the buildings, techs, fleets or defense
	    		try {
	    			entry = entries[i];
		    		// new approach - End of May 2009 until ... but this time language independant :-)
    				try {
		    			var tmp = entry.getElementsByTagName("a")[0].getAttributeNode("ref").value;
		    			tmp = parseInt(tmp);
			    		name[j] = eu.galaxytool.GTPlugin_planet_data.getEnglishNameForID(tmp);
    				} catch(type_2) {
    					try {
	    					// some items do not offer "ref" item on first link
			    			var tmp = entry.getElementsByTagName("a")[1].getAttributeNode("ref").value;
			    			tmp = parseInt(tmp);
				    		name[j] = eu.galaxytool.GTPlugin_planet_data.getEnglishNameForID(tmp);
    					} catch(building_in_construction) {
	    					// some items do not offer "ref" item on first link
			    			var tmp = entry.getElementsByTagName("a")[0].getAttributeNode("href").value;
			    			// index.php?page=resources&session=589cc1f0a46d&modus=1&techid=1&menge=1
			    			tmp = tmp.match(/techid=(\d+)/)[1];
			    			tmp = parseInt(tmp);
				    		name[j] = eu.galaxytool.GTPlugin_planet_data.getEnglishNameForID(tmp);
    					}
    				}
    				
    				amount[j] = 0; // initialize value to have no gaps in our arrays
    				// amount - first try "title tag"
    				try {
    					/*
    					tmp = entry.getElementsByTagName("a")[0].getAttributeNode("title").value;
    					tmp = tmp.match(/([\d+\.]+)/)[1];
    					amount[j] = tmp.replace(/[^0-9]/g,"");
    					j++;
    					* */
    					
    					// try next way
			    		k=0;
			    		while (tmp = entry.getElementsByTagName("span")[k]) {
			    			try {
				    			var classname = tmp.getAttributeNode("class").value;
				    			if (classname == "level") {
				    				// Technocrat = "2 (+2)" at espionage technique
				    				// innerHTML: <span class="textlabel">Spionagetechnik </span>17<span class="undermark">(+2)</span>
                                    if (tmp.innerHTML.indexOf("(") > 0) {
				    					amount [j] = parseInt(tmp.innerHTML.substring(0,tmp.innerHTML.indexOf("(")).replace(/[^0-9]/g,""))+2;
				    					j++;
				    				} else {
				    					amount[j] = tmp.innerHTML.replace(/[^0-9]/g,"");
				    					j++;
				    					break;
				    				}
				    			}
			    			} catch(no_class_attribute_found) {
			    				// nothing to do
			    			}
			    			k++;
			    		}
    				} catch(what_happened) {
						alert("unexpected error");
    				}
	    			
	    		} catch(no_error) {
	    			alert("unexpected error occured"+no_error);
	    			// nothing to do
	    		}
	    	}
	    	
	    	if (return_string == true) {
		        var data = "";
		        var namedata = "";
		        var amountdata = "";
		       	
		       	var active_planetname,coords,moon_or_planet;
		       	[active_planetname,coords,moon_or_planet] = this.getPlanetname(docroot)
		     		       
		        var galaxy = coords.match(/\[(\d+)\:/)[1];
		        var system = coords.match(/\:(\d+)\:/)[1];
		        var planet = coords.match(/\:(\d+)\]/)[1];
		        var playername = docroot.getElementById("playerName").getElementsByTagName("span")[0].innerHTML;
		       
		        var planet_xml = '	<planetinfo playername="'+playername+'" planetname="'+active_planetname+'" moon="'+(moon_or_planet=="moon")+
		        				 '" galaxy="'+galaxy+'" system="'+system+'" planet="'+planet+'">'+'\n';
	
				planet_xml += '		<entry name="Metal" amount="'+this.get_resources(docroot,"resources_metal")+'"/>'+'\n';
				planet_xml += '		<entry name="Crystal" amount="'+this.get_resources(docroot,"resources_crystal")+'"/>'+'\n';
				planet_xml += '		<entry name="Deuterium" amount="'+this.get_resources(docroot,"resources_deuterium")+'"/>'+'\n';
				planet_xml += '		<entry name="Energy" amount="'+this.get_resources(docroot,"resources_energy")+'"/>'+'\n';
				
		        if (previous_data != null) {
		        	for (i=0;i<previous_data.length;i++) {
		        		for (var arrayname in previous_data[i]) {
		        			switch(arrayname) {
		        				case "name":
		        					namedata   += previous_data[i][arrayname]+"|"; 
		        					break;
		        				case "amount":
		        					amountdata += previous_data[i][arrayname]+"|";
		        					break;
		        			}
		        			
		        		}
		        	}
		        	
		        	//create xml-string of previous data
		        	for (i=0;i<previous_data.length;i++) {
		        		if (previous_data[i]["amount"] != 0) {
		        			planet_xml += '		<entry name="'+previous_data[i]["name"]+'" amount="'+previous_data[i]["amount"]+'"/>'+'\n';
		        		}
		        	}
		        }
		        
		        //add the rest to the xml-string
		        for(i = 0; i < name.length; i++) {
		        	if (amount[i] != 0) {
		        		planet_xml += '		<entry name="'+name[i]+'" amount="'+amount[i]+'"/>'+'\n';
		        	}
		        }
		        
		        planet_xml += '	</planetinfo>'+'\n';
		        
		       	if(param_name == "base4") {
					param_name = "techs";
				}
				
		        data += "&"+param_name+"=" + namedata + name.join("|");
		        data += "&amount=" + amountdata + amount.join("|");
		        return [data,planet_xml];
		        
	    	} else {
	    		// return as object
				var data = new Array();
				
				j = 0;
				if (previous_data != null) {
					data = previous_data;
					j = previous_data.length;
				}
	
				for (i=0; i<name.length;i++) {
					data[j] = new Object();
					data[j]["name"]   = name[i];
					data[j]["amount"] = amount[i];
					j++;
				}
		        return data;
	    	}
	
	    } catch (e) {
	    	alert("error at getData: "+e);
	    	return "";
	    }
	    return "";
	}

}

