if(!eu) var eu={};
if(!eu.galaxytool) eu.galaxytool={};
if(!eu.galaxytool.GTPlugin_reports) eu.galaxytool.GTPlugin_reports={};


eu.galaxytool.GTPlugin_reports={
	
	findSingleReport: function() {
		if (eu.galaxytool.GTPlugin_general.Messagedoc == null) {
			return;
		} 
		
		var header = eu.galaxytool.GTPlugin_general.Messagedoc.getElementById("wrapper").getElementsByTagName("div")[1].getElementsByTagName("tr")[3];
		var language = eu.galaxytool.GTPlugin_general.get_language(eu.galaxytool.GTPlugin_general.Messagedoc.location.href.toString());
		
		var report_content,report_content_xml;
		[report_content,report_content_xml] = eu.galaxytool.GTPlugin_reports.extract_report(eu.galaxytool.GTPlugin_general.Messagedoc,header,"messagebox",language);	
		
	    if (report_content == "") {
		    if (eu.galaxytool.GTPlugin_general.debug_mode == true) {
		    	eu.galaxytool.GTPlugin_general.set_status(eu.galaxytool.GTPlugin_general.Messagedoc, "galaxyplugin"+1 , 0, "No reports found");
		    }
	    	return;	
	    }
		
	    eu.galaxytool.GTPlugin_general.set_status(eu.galaxytool.GTPlugin_general.Messagedoc, "galaxyplugin"+1 , 0, eu.galaxytool.GTPlugin_general.getLocString("reportsfound"));	
	
		try {
			// add workaround to avoid changes at current galaxytool version
			report_content = '<td colspan="3" class="b">' + report_content;
			
		    GTPlugin_result = eu.galaxytool.GTPlugin_general.send(eu.galaxytool.GTPlugin_general.Messagedoc,"reports",report_content,report_content_xml,eu.galaxytool.GTPlugin_general.Messagedoc.location.href);
		} catch(e) {
			// unexpected error
		    eu.galaxytool.GTPlugin_general.set_status(eu.galaxytool.GTPlugin_general.Messagedoc, "galaxyplugin"+1 , 0, "FindSinglereport() unexpected error: "+e);
		}	
	},
	
	findMultipleReport: function() {
		var report_content = "";
		var report_content_xml = "";
		try {
			var tr;
			var tr_id;
			var header;
			var i = 2;
			var language = eu.galaxytool.GTPlugin_general.get_language(eu.galaxytool.GTPlugin_general.Messagedoc.location.href.toString())
			eu.galaxytool.GTPlugin_init.update_universe_at_settings(eu.galaxytool.GTPlugin_general.Messagedoc);
			if (eu.galaxytool.GTPlugin_storage.target_tool_exists(eu.galaxytool.GTPlugin_general.Messagedoc.location.href,"reports") == true) {
				while (tr = eu.galaxytool.GTPlugin_general.Messagedoc.getElementById("mailz").getElementsByTagName("tr")[i]) {
					try {
						if (tr.getAttributeNode("id").value.indexOf("spioDetails") > -1) {
							header = eu.galaxytool.GTPlugin_general.Messagedoc.getElementById("mailz").getElementsByTagName("tr")[i-1];
							
							var single_report_content, single_report_content_xml;
							
							// JS Eclipse shows an error, but since Javascript 1.7 (Firefox 2) you can do something like this:
							// see https://developer.mozilla.org/en/new_in_javascript_1.7#Multiple-value_returns
							[single_report_content, single_report_content_xml] = eu.galaxytool.GTPlugin_reports.extract_report(tr,header,tr.getAttributeNode("id").value,language);
							
							
							if (single_report_content != "") {
								// add workaround to avoid changes at current galaxytool version
								report_content += '<td colspan="3" class="b">' + single_report_content;
							}
							
							if (single_report_content_xml == false) {
								break;
							}
							
							if (single_report_content_xml != "") {
								report_content_xml += single_report_content_xml;
							}
							

						}
						i++;	
					} catch(no_spiomessage) {
						// nothing to do
						i++;
					}
					
				}
			}
		} catch(error) {
			// error occured, but we ignore it
		}
		
		//alert(report_content_xml);
				
	    if (report_content == "" || report_content_xml == "") {
	    	eu.galaxytool.GTPlugin_general.set_status(eu.galaxytool.GTPlugin_general.Messagedoc, "galaxyplugin"+1 , 0, "No reports found");
	    		return;
	    }
		
	    eu.galaxytool.GTPlugin_general.set_status(eu.galaxytool.GTPlugin_general.Messagedoc, "galaxyplugin"+1 , 0, eu.galaxytool.GTPlugin_general.getLocString("reportsfound"));	
	
		try {
		    GTPlugin_result = eu.galaxytool.GTPlugin_general.send(eu.galaxytool.GTPlugin_general.Messagedoc,"reports",report_content,report_content_xml,eu.galaxytool.GTPlugin_general.Messagedoc.location.href);
		} catch(e) {
			// unexpected error
		    eu.galaxytool.GTPlugin_general.set_status(eu.galaxytool.GTPlugin_general.Messagedoc, "galaxyplugin"+1 , 0, "FindMultipleReport() unexpected error: "+e);
		}		
	},
	
	extract_report: function(doc,header,container_id,language) {
		
		var coords;
		var galaxy;
		var system;
		var planet;
		
		//this is the only language dependent thing
		var planetname;
		var planetname_exp = this.get_planetname_pattern(language);
		
		var playername;
		
		//date including year!
		//06.08.2010 14:43:34
		var date_exp = /(\d{2}).(\d{2}).(\d{4})\s(.+)/;
		try {
			var tmp = header.getElementsByTagName("td")[3].innerHTML;
		} catch(single_report) {
			var tmp = header.getElementsByTagName("td")[0].innerHTML;
		}
		
		tmp = date_exp.exec(tmp)
		var date = tmp[3]+"."+tmp[2]+"."+tmp[1]+" "+tmp[4];
		//converted to varchar(19)
		
		var contents = new Array();
		var values = new Array();
				
		// find report
		var trow;
		var i = 0;
		var j = 0;
	    var found = 0;
	    var scan_depth = 0;
	    var report_content = "";
		while (trow = eu.galaxytool.GTPlugin_general.Messagedoc.getElementById(container_id).getElementsByTagName("tr")[i]) {
			i++;
			// check each tr content
			try {
				if (trow.cells.length == 4) {
					// Resources have:
					// cell 1 + 3 = class "item"
					if (trow.cells[0].getAttributeNode("class").value == "item" &&
					    trow.cells[2].getAttributeNode("class").value == "item") {

					    //normal string					    
					    report_content += trow.cells[0].innerHTML + " " + trow.cells[1].innerHTML + "\t";
					    report_content += trow.cells[2].innerHTML + " " + trow.cells[3].innerHTML + "\n";
					    
					    // workaround for current galaxytool version
					    report_content += "</tr>";					    
					    
					    //for XML
					    contents.push(trow.cells[0].innerHTML);
					    values.push(parseInt(trow.cells[1].innerHTML.replace(/[^0-9]/g,"")));
					    contents.push(trow.cells[2].innerHTML);
					    values.push(parseInt(trow.cells[3].innerHTML.replace(/[^0-9]/g,""))); 
			    
					}
					// all attributes except resources have:
					// cell 1 + 3 = class "key"
					// cell 2 + 4 = class "value"
					if (trow.cells[0].getAttributeNode("class").value == "key" &&  
	  					trow.cells[1].getAttributeNode("class").value == "value" &&
	  					trow.cells[2].getAttributeNode("class").value == "key" &&  
	  					trow.cells[3].getAttributeNode("class").value == "value") {
					    
					    //normal string
					    report_content += trow.cells[0].innerHTML + " " + trow.cells[1].innerHTML + "\t";
					    report_content += trow.cells[2].innerHTML + " " + trow.cells[3].innerHTML + "\n";
					    
					    // workaround for current galaxytool version
					    report_content += "</tr>";
					    
					    //for XML
					    contents.push(trow.cells[0].innerHTML);
					    values.push(parseInt(trow.cells[1].innerHTML.replace(/[^0-9]/g,"")));
					    contents.push(trow.cells[2].innerHTML);
					    values.push(parseInt(trow.cells[3].innerHTML.replace(/[^0-9]/g,"")));  				    
					   
					}
				} else if (trow.cells.length == 2) {
					// just in case only one entry at the line
					if (trow.cells[0].getAttributeNode("class").value == "key" &&  
	  					trow.cells[1].getAttributeNode("class").value == "value") {
					    
					    //normal string
					    report_content += trow.cells[0].innerHTML + " " + trow.cells[1].innerHTML + "\n";
					    
						// workaround for current galaxytool version
					    report_content += "</tr>";
					    
					    //for XML
					    contents.push(trow.cells[0].innerHTML);
					    values.push(parseInt(trow.cells[1].innerHTML.replace(/[^0-9]/g,"")));
					  
					}
				} else if (trow.cells.length == 1) {
					// table header contains planetname and that stuff
					var thead = trow.getElementsByTagName("th")[0];
					if (thead.getAttributeNode("class").value == "area") {
						// we found the table header we were looking for
						
						//for XML
						try {
							var coords_exp = /(\d+):(\d+):(\d+)/;
							coords = coords_exp.exec(thead.getElementsByTagName("a")[0].innerHTML);
							galaxy = coords[1];
							system = coords[2];
							planet = coords[3];
						} catch (e) {
							//no Header
						}
												
						thead = thead.innerHTML;
					
						if (report_content == "") {
							// planetname and that stuff
							
							//for XML
							playername = thead.match(/\(.+\s\'(.+)\'\)/)[1];
							planetname = thead.match(planetname_exp)[1];
							
							// workaround for Resources at to transfer to Resources on as it was before
							thead = thead.replace(/Resources at/g,"Resources on");
							
							// workaround for current galaxytool version
						    report_content = thead.replace(/\<br\>/g,"") + "\n" + "</tr>" + report_content;
						} else {
							// Fleet, defense, buildings, techs (and activity)
							scan_depth++;
							
							report_content = report_content + thead + "\n";
						    // workaround for current galaxytool version
						    report_content += "</tr>";
						}
					}
				}
			} catch(no_error) {
				// we will halt here in case "class" attribute does not exist
			}
		}
		
		//translate each value to English
		var tool_ids = eu.galaxytool.GTPlugin_storage.read_tool_ids_for_ogame_url(eu.galaxytool.GTPlugin_general.Messagedoc.location.href);
		if(tool_ids.length > 0) {
			contents = this.translate_array(tool_ids[0],contents);
		}
		
		// no translations were available - did not view the techtree
		if (contents == false) {
			return [report_content,false];
		} 

		//create xml from everything
		var report_xml = this.create_report_xml_string(playername,planetname,galaxy,system,planet,date,scan_depth,contents,values);
		
		/*
		//create xml-doc out of string
		var parser = new DOMParser();  
   		var xml_doc = parser.parseFromString(this.create_report_xml_string(playername,planetname,galaxy,system,planet,date,contents,values), "text/xml");  
		
		//create string out of DOM-tree
		var serializer = new XMLSerializer();
		var xml_string = serializer.serializeToString(xml_doc);
		*/
		
		return [report_content,report_xml];
	},
	
		
	get_planetname_pattern: function(language) {
		switch(language) {
			case "de"		: return /^Rohstoffe auf\s(.+)\s</; 	//German
			case "org"		: return /^Resources at\s(.+)\s</; 		//English
			case "com.es"	: return /^Recursos en\s(.+)\s</;		//Spanish
			case "tw"		: return /時\s(.+)\s</;					//Taiwanese
			case "ba.org"	: return /^Resursi na\s(.+)\s</;		//Balkan
			case "dk"		: return /^Ressurcer på\s(.+)\s</;		//Danish
			case "gr"		: return /^Πόροι στο\s(.+)\s</;			//Greek
			case "com.hr"	: return /^Resursi na\s(.+)\s</;		//Croatian
			case "hu"		: return /^Nyersanyagok itt:\s(.+)\s</;	//Hungarian
			case "fr"		: return /^Ressources sur\s(.+)\s</;	//French
			case "fi.org"	: return /^Resurssit\s(.+)\s</;			//Finnish
			case "it"		: return /^Risorse su\s(.+)\s</;		//Italian
			case "jp"		: return /時点の(.+)\s</;				//Japanese
			case "nl"		: return /^Grondstoffen op\s(.+)\s</;	//Dutch
			case "lv"		: return /^Resursi uz\s(.+)\s</;		//Latvian
			case "lt"		: return /^Resursų\s(.+)\s</;			//Lituanian
			case "pl"		: return /^Surowce na\s(.+)\s</;		//Polish
			case "com.pt"	: return /^Recursos em\s(.+)\s</;		//Portuguese
			case "no"		: return /^Ressurser på\s(.+)\s</;		//Norwegian
			case "rs"		: return /^Ресурси на\s(.+)\s</;		//Serbian
			case "se"		: return /^Resurser på\s(.+)\s</;		//Swedish
			case "ro"		: return /^Resurse la\s(.+)\s</;		//Romanian
			case "ru"		: return /^Сырьё на\s(.+)\s</;			//Russian
			case "us"		: return /^Resources at\s(.+)\s</;		//American
			case "tr.org"	: return /tarihinde\s(.+)\s</;			//Turkish
			case "com.br"	: return /^Recursos no\s(.+)\s</;		//Brazilian
			case "cz"		: return /^Suroviny na\s(.+)\s</;		//Czech
			case "com.ar"	: return /^Recursos en\s(.+)\s</;		//Argentinian
			case "sk"		: return /^Zdroje na\s(.+)\s</;			//Slovak
			case "bg.org"	: return /^Ресурси на\s{2}(.+)\s</;		//Bulgarian
			case "mx.org"	: return /^Recursos en\s(.+)\s</;		//Mexican
			case "si"		: return /^Surovine na\s(.+)\s</;		//Slovenian
			case "ae.org"	: return /^موارد على\s(.+)\s</;			//Arabic
			default			: return /^Resources at\s(.+)\s</;		//English as default
		}
	},
	
	
	translate_array: function(tool_id,array) {
		var translation = new Array();
		var tmp;
		//the first four entries are always Metal,Crystal, Deut and Energy
		translation.push("Metal");
		translation.push("Crystal");
		translation.push("Deuterium");
		translation.push("Energy");
		
		for (var i=4;i < array.length; i++) {
			tmp = eu.galaxytool.GTPlugin_storage.get_translation(tool_id,array[i])
			if(tmp != "Unknown entry") {
				translation.push(tmp);
			} else {
				return false;
			}
		}
		
		return translation;
	},
	
	create_report_xml_string: function(playername,planetname,galaxy,system,planet,datetime,scandepth,translated_contents,values) {
		var content = "";
		
		var depth;
		
		switch(scandepth) {
			case 1: depth = "resources"; 
					break;
			case 2: depth = "fleet";
					break;
			case 3: depth = "defence";
					break;
			case 4: depth = "buildings";
					break;
			case 5: depth = "research";
					break;
		}
		
		//TODO: create table of moons, and check, if the moon_name is equal to given planet_name -> then it is a moon
		//but what to do, when moon and planet have the same name?!
		var moon = planetname.indexOf("(") > -1
		
		content +=  '	<report playername="'+playername+'" planetname="'+planetname+'" moon="'+moon+
					'" galaxy="'+galaxy+'" system="'+system+'" planet="'+planet+'" datetime="'+datetime+
					'" scandepth="'+depth+'">'+'\n';
					
		for (var i = 0;i < values.length; i++) {
			content += '		<entry name="'+translated_contents[i]+'" amount="'+values[i]+'"/>'+'\n';
		}
		
		content += '	</report>'+'\n';
		
		return content;
		
	}

}
