if(!eu) var eu={};
if(!eu.galaxytool) eu.galaxytool={};
if(!eu.galaxytool.GTPlugin_options2) eu.galaxytool.GTPlugin_options2={};

eu.galaxytool.GTPlugin_options2={
	// new functions for new galaxytool options layout
	
	selected_tool: null,
	tools:        new Array(),
	do_not_set_fields : false,

	initWindow: function() {
	   	eu.galaxytool.GTPlugin_storage.initStorage();
	   	this.loadValues();
	   	
	   	if (this.tools.length == 0) {
	   		this.add_new_tool();
	   	} else {
	   		// select first one
	   		this.selected_tool = 0;
	   		this.set_userdata();
	   	}
	  
	  	
	   	
	},
	
	copy_userdata: function() {
		try {
		    //alert("pressed "+variable.getAttribute("label"));
		    if (this.selected_tool == null) {
		    	// we did not have a tool selected yet
		    	return;
		    }
		    	
		    // copy previous values into array that shall be saved later on
		    // textfields
			this.tools[this.selected_tool]["name"]          = document.getElementById("GTPlugin-name").value;
			this.tools[this.selected_tool]["ogame_url"]     = document.getElementById("GTPlugin-ogameurl").value;
			this.tools[this.selected_tool]["tool_url"]      = document.getElementById("GTPlugin-url").value;
			this.tools[this.selected_tool]["tool_user"]     = document.getElementById("GTPlugin-username").value;
			this.tools[this.selected_tool]["tool_password"] = document.getElementById("GTPlugin-password").value;

			// universe data checkboxes
			this.tools[this.selected_tool]["submit_galaxy"]   = document.getElementById("GTPlugin-submit_galaxy")  .getAttribute("checked");
			this.tools[this.selected_tool]["submit_stats"]    = document.getElementById("GTPlugin-submit_stats")   .getAttribute("checked");
			this.tools[this.selected_tool]["submit_reports"]  = document.getElementById("GTPlugin-submit_reports") .getAttribute("checked");
			this.tools[this.selected_tool]["submit_allypage"] = document.getElementById("GTPlugin-submit_allypage").getAttribute("checked");
			
			// own data checkboxes
			this.tools[this.selected_tool]["submit_buildings"] = document.getElementById("GTPlugin-submit_buildings").getAttribute("checked");
			this.tools[this.selected_tool]["submit_research"]  = document.getElementById("GTPlugin-submit_research") .getAttribute("checked");
			this.tools[this.selected_tool]["submit_fleet"]     = document.getElementById("GTPlugin-submit_fleet")    .getAttribute("checked");
			this.tools[this.selected_tool]["submit_defense"]   = document.getElementById("GTPlugin-submit_defense")  .getAttribute("checked");
			this.tools[this.selected_tool]["submit_empire"]    = document.getElementById("GTPlugin-submit_empire")  .getAttribute("checked");
				
		} catch(error) {
			alert("copy_userdata: "+error);
		}	
	},
	
	set_userdata: function() {
		try {
			if (this.selected_tool == null) {
				return;
			}
			if (this.tools == null) {
				return;
			}
			
			// set values at text fields
			document.getElementById("GTPlugin-caption").setAttribute("label", this.tools[this.selected_tool]["name"]);
			document.getElementById("GTPlugin-name").value     = this.tools[this.selected_tool]["name"];
			document.getElementById("GTPlugin-ogameurl").value = this.tools[this.selected_tool]["ogame_url"];
			document.getElementById("GTPlugin-url").value      = this.tools[this.selected_tool]["tool_url"];
			
			var version;
			if (this.tools[this.selected_tool]["tool_version_major"] == 0) {
				 version = "≤4.5.4 or not inserted"; 
			} else {
				version = this.tools[this.selected_tool]["tool_version_major"]+
				"."+this.tools[this.selected_tool]["tool_version_minor"]+
				"."+this.tools[this.selected_tool]["tool_version_revision"];
			}
																
			document.getElementById("GTPlugin-version").value  = version;
																 
			document.getElementById("GTPlugin-username").value = this.tools[this.selected_tool]["tool_user"];
			document.getElementById("GTPlugin-password").value = this.tools[this.selected_tool]["tool_password"];
			document.getElementById("GTPlugin-uni").value      = this.tools[this.selected_tool]["universe"];
			
			if (this.tools[this.selected_tool]["universe"] == "unknown" ) {
				document.getElementById("GTPlugin-uni").setAttribute("class","gt_label_uni_not_okay");	
			} else {
				document.getElementById("GTPlugin-uni").setAttribute("class","gt_label_uni_okay");
			}
				  
			// universe data checkboxes
			document.getElementById("GTPlugin-submit_galaxy")  .setAttribute("checked", this.tools[this.selected_tool]["submit_galaxy"]);
			document.getElementById("GTPlugin-submit_stats")   .setAttribute("checked", this.tools[this.selected_tool]["submit_stats"]);
			document.getElementById("GTPlugin-submit_reports") .setAttribute("checked", this.tools[this.selected_tool]["submit_reports"]);
			document.getElementById("GTPlugin-submit_allypage").setAttribute("checked", this.tools[this.selected_tool]["submit_allypage"]);
			
			// own data checkboxes
			document.getElementById("GTPlugin-submit_buildings").setAttribute("checked", this.tools[this.selected_tool]["submit_buildings"]);
			document.getElementById("GTPlugin-submit_research") .setAttribute("checked", this.tools[this.selected_tool]["submit_research"]);
			document.getElementById("GTPlugin-submit_fleet")    .setAttribute("checked", this.tools[this.selected_tool]["submit_fleet"]);
			document.getElementById("GTPlugin-submit_defense")  .setAttribute("checked", this.tools[this.selected_tool]["submit_defense"]);
			document.getElementById("GTPlugin-submit_empire")   .setAttribute("checked", this.tools[this.selected_tool]["submit_empire"]);
			
		} catch(error) {
			alert("set_userdata: "+error);
		}
		
	},
	
	load_selected_tool: function(menuitem) {
		try {
			if (this.do_not_set_fields == true) {
				// we just want to set the focus to the new line without copying data
				this.do_not_set_fields = false;
				return;
			}
		    //alert("pressed "+variable.getAttribute("label"));
			// copy user entered data into array
		    this.copy_userdata();

		    // now set the newly selected tool as global defined tool
		    this.selected_tool = menuitem.getAttribute("value");
		    
		    // set userdata for selected tool
			this.set_userdata()

		
		} catch(error) {
			alert("error at load tool: "+e);
		}
	},
	
	add_new_tool: function() {
		try {
			var array_index = this.tools.length;
			this.tools[array_index] = new Object();
			this.tools[array_index]["id"]            		= null;
			this.tools[array_index]["deleted"]       		= false;
			this.tools[array_index]["updated"]       		= false;
			this.tools[array_index]["name"]          		= "New Tool";
			this.tools[array_index]["ogame_url"]    		= "uni10.ogame.org";
			this.tools[array_index]["tool_url"]      		= "http://yourdomain.tld/galaxytool/secret/galaxyplugin.php";
			this.tools[array_index]["tool_version_major"]    = 0;
			this.tools[array_index]["tool_version_minor"]    = 0;
			this.tools[array_index]["tool_version_revision"] = 0;
			this.tools[array_index]["tool_user"]     		= "";
			this.tools[array_index]["tool_password"] 		= "";
			this.tools[array_index]["universe"]      		= "unknown";

			// universe data checkboxes
			this.tools[array_index]["submit_galaxy"]   = "true";
			this.tools[array_index]["submit_stats"]    = "true";
			this.tools[array_index]["submit_reports"]  = "true";
			this.tools[array_index]["submit_allypage"] = "true";
			
			// own data checkboxes
			this.tools[array_index]["submit_buildings"] = "true";
			this.tools[array_index]["submit_research"]  = "true";
			this.tools[array_index]["submit_fleet"]     = "true";
			this.tools[array_index]["submit_defense"]   = "true";
			this.tools[array_index]["submit_empire"]    = "true";
			
			// add item to menulist
 			this.tools[array_index]["menuitem"] = document.getElementById("GTPlugin-tool_list").appendItem( this.tools[array_index]["name"]+" - ", array_index, this.tools[array_index]["ogame_url"] );

			
	    	if (this.selected_tool != null) {
	 			// backup old values first
	 			this.copy_userdata();
	    	}
 			
 			this.selected_tool = this.tools.length - 1;
 			
 			// select new tool in dropdown
 			this.do_not_set_fields = true;
 			document.getElementById("GTPlugin-tool_list").selectedIndex = this.selected_tool; 
 			
 			// set new data at fields
 			this.set_userdata();
 			 			
		} catch(e) {
			alert("error at add tool: "+e);
		}
	},
	
	delete_tool: function() {
		try {
			// this.selected_tool contains currently selected tool
			if (this.selected_tool == null) {
				// nothing to delete
				return;
			}
			
			// database done in save only
			// hide item at list
			this.tools[this.selected_tool]["menuitem"].style.display="none";
			
			// array content will be lost as soon as the window is closed; but mark it as deleted
			this.tools[this.selected_tool]["deleted"] = true;
			
			// select another tool which is not yet marked as deleted
			var remaining_tools = false;		
			for (var i=0; i < this.tools.length; i++) {
				if (this.tools[i]["deleted"] == false) {
					this.selected_tool = i;
					this.set_userdata();
					remaining_tools = true;
					
					// select tool in dropdown
 					this.do_not_set_fields = true;
 					document.getElementById("GTPlugin-tool_list").selectedIndex = this.selected_tool; 
					
					return;			
				}
			}
			if (remaining_tools == false) {
				// we did not find any remaining tool
				this.add_new_tool();
			}
		} catch(error) {
			alert("delete tool error: "+error);
		}
	},
	
	on_ogame_url_changed: function() {
		try {
			// change the menuitem description
			this.tools[this.selected_tool]["menuitem"].setAttribute("description",document.getElementById("GTPlugin-ogameurl").value);
			this.tools[this.selected_tool]["universe"]    = "";
			document.getElementById("GTPlugin-uni").value = this.tools[this.selected_tool]["universe"];
			document.getElementById("GTPlugin-uni").setAttribute("class","gt_label_uni_not_okay");
			this.on_change();
		} catch(error) {
			alert("reset uni error: "+error);
		}
	},
	
	on_galaxytool_url_changed: function() {
		try {
			this.tools[this.selected_tool]["tool_version_major"]    = 0;
			this.tools[this.selected_tool]["tool_version_minor"]    = 0;
			this.tools[this.selected_tool]["tool_version_revision"] = 0;
			document.getElementById("GTPlugin-version").value = "≤4.5.4 or not inserted";
			this.on_change();
		} catch(error) {
			alert("reset Galaxytool version error: "+error);
		}
	},
	
	on_change: function() {
		try {
		this.tools[this.selected_tool]["updated"] = true;
		} catch(error) {
			alert("on change: "+error);
		}
	},
	
	on_name_changed: function() {
		// handle name changes
		try {
			// change the menuitem description
			this.tools[this.selected_tool]["menuitem"].setAttribute("label",document.getElementById("GTPlugin-name").value);
			this.on_change();
		} catch(error) {
			alert("on name changed: "+error);
		}
	},
		
	getPrefs: function() {
	  return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	},
			
	loadValues: function() {
		try {
		    var prefs = this.getPrefs();
		    // debug information
		    if (prefs.prefHasUserValue("gtplugin.settings.debug")) {
		        var debug = prefs.getBoolPref("gtplugin.settings.debug");
		        document.getElementById("GTPlugin-debug").checked = debug;
		    }
		    // status window
		    if (prefs.prefHasUserValue("gtplugin.settings.show_statuswindow")) {
		        var show_statuswindow = prefs.getBoolPref("gtplugin.settings.show_statuswindow");
		        document.getElementById("GTPlugin-show_statuswindow").checked = show_statuswindow;
		    }
		
		    // Status window styles
		    var style;
		    if (prefs.prefHasUserValue("gtplugin.status_style_window")) {
		        style = prefs.getCharPref("gtplugin.status_style_window");
		        document.getElementById("GTPlugin-status_style_window").value = style;
		    } else {
		    	// default value
		    	document.getElementById("GTPlugin-status_style_window").value = "position:fixed;top:10px;left:10px;z-index: 999;border: solid white 1px;width:250px;padding:2px;";
		    }
		    if (prefs.prefHasUserValue("gtplugin.status_style_header")) {
		        style = prefs.getCharPref("gtplugin.status_style_header");
		        document.getElementById("GTPlugin-status_style_header").value = style;
		    } else {
		    	// default value
		    	document.getElementById("GTPlugin-status_style_header").value = "font-weight:bold;";
		    }
		    if (prefs.prefHasUserValue("gtplugin.status_style_results")) {
		        style = prefs.getCharPref("gtplugin.status_style_results");
		        document.getElementById("GTPlugin-status_style_results").value = style;
		    } else {
		    	// default value
		    	document.getElementById("GTPlugin-status_style_results").value = "color:white;";
		    }		
		    
		    // load tool specific information from SQLite
		    this.tools = eu.galaxytool.GTPlugin_storage.read_tools();
		    
			// add items to menulist
			for (var i=0; i< this.tools.length; i++) {
				this.tools[i]["menuitem"] = document.getElementById("GTPlugin-tool_list").appendItem( this.tools[i]["name"]+" - ", i, this.tools[i]["ogame_url"] );				
			}
 			
		    
		    
		} catch(error) {
			alert("loadValues error: "+error);
		}
	},
		
	saveValues: function() {
		try {
			// as a first step, copy values from input fields into array
			this.copy_userdata();
			
			var prefs = this.getPrefs();
			
			// Settings stored in PREF 
		    prefs.setBoolPref("gtplugin.settings.debug"            , document.getElementById("GTPlugin-debug").checked);            // set a pref
		    prefs.setBoolPref("gtplugin.settings.show_statuswindow", document.getElementById("GTPlugin-show_statuswindow").checked);   // set a pref
		
			// Status window
			prefs.setCharPref("gtplugin.status_style_window", decodeURIComponent(this.getValue("GTPlugin-status_style_window")));
			prefs.setCharPref("gtplugin.status_style_header", decodeURIComponent(this.getValue("GTPlugin-status_style_header")));
			prefs.setCharPref("gtplugin.status_style_results", decodeURIComponent(this.getValue("GTPlugin-status_style_results")));
			
			// data stored in SQLite 
			for (var i=0; i<this.tools.length; i++) {
				var tool_exists = eu.galaxytool.GTPlugin_storage.tool_exists(this.tools[i]["id"]);
				if (this.tools[i]["deleted"] == false && !tool_exists) {
					// insert data into SQLite only, if the tool was not created yet and is not marked as deleted
					eu.galaxytool.GTPlugin_storage.insert_tool(
						this.tools[i]["id"],
						this.tools[i]["name"],
						this.tools[i]["ogame_url"],
						this.tools[i]["tool_url"],
						this.tools[i]["tool_version_major"],
						this.tools[i]["tool_version_minor"],
						this.tools[i]["tool_version_revision"],
						this.tools[i]["tool_user"],
						this.tools[i]["tool_password"],
						this.tools[i]["universe"],
						// universe data checkboxes
						this.tools[i]["submit_galaxy"],
						this.tools[i]["submit_stats"],
						this.tools[i]["submit_reports"],
						this.tools[i]["submit_allypage"],
						// own data checkboxes
						this.tools[i]["submit_buildings"],
						this.tools[i]["submit_research"],
						this.tools[i]["submit_fleet"],
						this.tools[i]["submit_defense"],
						this.tools[i]["submit_empire"]);
						
						this.tools[i]["updated"] = false;
						
				} else if (this.tools[i]["deleted"] == true && tool_exists) {
					// delete tool from DB only, if the tool is marked as deleted and the tool exists
					eu.galaxytool.GTPlugin_storage.delete_tool(this.tools[i]["id"]);
						this.tools[i]["updated"] = false;
				}
				
				if (this.tools[i]["updated"] == true && tool_exists) {
					// update data only if necessary and tool exists
					
					eu.galaxytool.GTPlugin_storage.update_tool(
						this.tools[i]["id"],
						this.tools[i]["name"],
						this.tools[i]["ogame_url"],
						this.tools[i]["tool_url"],
						this.tools[i]["tool_version_major"],
						this.tools[i]["tool_version_minor"],
						this.tools[i]["tool_version_revision"],
						this.tools[i]["tool_user"],
						this.tools[i]["tool_password"],
						this.tools[i]["universe"],
						// universe data checkboxes
						this.tools[i]["submit_galaxy"],
						this.tools[i]["submit_stats"],
						this.tools[i]["submit_reports"],
						this.tools[i]["submit_allypage"],
						// own data checkboxes
						this.tools[i]["submit_buildings"],
						this.tools[i]["submit_research"],
						this.tools[i]["submit_fleet"],
						this.tools[i]["submit_defense"],
						this.tools[i]["submit_empire"]);
						
						this.tools[i]["updated"] = false;
						
				}
			}
			
			eu.galaxytool.GTPlugin_storage.close();
		    window.close();
		} catch (error) {
			alert("Save values error: "+error);
		}
	},
	
	cancel: function() {
	    window.close();
	},
	
	getValue: function(elementID) {
	    // Get a handle to our url textfield
	    var textfield = document.getElementById(elementID);
	    // Get the value, trimming whitespace as necessary
	    var string = this.trimString(textfield.value);
	
	    // If there is no url, we return ""
	    // Otherwise, we convert the search terms to a safe URI version and return it
	    if (string.length == 0) { return ""; }
	    else { return encodeURIComponent(string); }
	},
		
	trimString: function(string) {
	    // Return empty if nothing was passed in
	    if (!string) return "";
	
	    // Efficiently replace any leading or trailing whitespace
	    var value = string.replace(/^\s+/, '');
	    value = string.replace(/\s+$/, '');
	
	    // Replace any multiple whitespace characters with a single space
	    value = value.replace(/\s+/g, ' ');
	
	    // Return the altered string
	    return value;
	}
}