if(!eu) var eu={};
if(!eu.galaxytool) eu.galaxytool={};
if(!eu.galaxytool.GTPlugin_storage) eu.galaxytool.GTPlugin_storage={};

eu.galaxytool.GTPlugin_storage={
	
	file:           null,
	storageService: null,
	dbConn:         null,
	db_tools:       "galaxytool_tools",
	db_languages:	"galaxytool_languages",
	
	initStorage: function() {
		try {
		    var file = Components.classes["@mozilla.org/file/directory_service;1"]  
		                         .getService(Components.interfaces.nsIProperties)  
		                         .get("ProfD", Components.interfaces.nsIFile);  
		    file.append("galaxytool_options.sqlite");  
		      
		    var storageService = Components.classes["@mozilla.org/storage/service;1"]  
		                            .getService(Components.interfaces.mozIStorageService);  
		    var mDBConn = storageService.openDatabase(file); // Will also create the file if it does not exist  
		    this.dbConn = mDBConn;  

			// create table if it does not exist yet
			this.install();
		
		} catch(init_error) {
			alert("Storage INIT error: "+init_error);
			return;
		}
		
		
	},
	
	insert_tool: function(id,tool_name, ogame_url, tool_url, tool_version_major, tool_version_minor, 
						  tool_version_revision,  tool_user, tool_password, universe, s_galaxy, 
						  s_stats, s_reports, s_allypage, s_buildings, s_research, s_fleet, s_defense, s_empire ) {
		try {
			// delete old entry of that tool (if it exists)
			var statement = null;
			if (id != null) {
				// Tool was loaded from SQLite
				this.delete_tool(id);
			}
			
			statement = this.dbConn.createStatement('INSERT INTO "main"."'+this.db_tools+'" ' +
					'("tool_name","ogame_url","tool_url","tool_user","tool_password", "universe", ' +
					' "submit_galaxy","submit_stats","submit_reports","submit_allypage", ' +
					' "submit_buildings","submit_research","submit_fleet","submit_defense", "submit_empire", '+
					' "tool_version_major","tool_version_minor", "tool_version_revision") VALUES ' +
					'(:tool_name, :ogame_url, :tool_url, :tool_user, :tool_password, :universe, ' +
					':submit_galaxy, :submit_stats, :submit_reports, :submit_allypage, ' +
					':submit_buildings, :submit_research, :submit_fleet, :submit_defense, :submit_empire, ' +
					':tool_version_major, :tool_version_minor, :tool_version_revision )');  
			
			// general data - prepared statement is providing security for SQL injections
			statement.params.tool_name        = tool_name; 
			statement.params.ogame_url        = ogame_url; 
			statement.params.tool_url         = tool_url; 
			statement.params.tool_user        = tool_user; 
			statement.params.tool_password    = tool_password;
			statement.params.universe         = universe; 
					
			// universe data
			statement.params.submit_galaxy    = (s_galaxy == "true"   || s_galaxy == true)      ? "true" : "false";
			statement.params.submit_stats     = (s_stats == "true"    || s_stats == true)       ? "true" : "false"; 
			statement.params.submit_reports   = (s_reports == "true"  || s_reports == true)     ? "true" : "false"; 
			statement.params.submit_allypage  = (s_allypage == "true" || s_allypage == true)    ? "true" : "false";
			
			// own data
			statement.params.submit_buildings = (s_buildings == "true" || s_buildings == true) ? "true" : "false";
			statement.params.submit_research  = (s_research == "true"  || s_research == true)  ? "true" : "false";
			statement.params.submit_fleet     = (s_fleet == "true"     || s_fleet == true)     ? "true" : "false"; 
			statement.params.submit_defense   = (s_defense == "true"   || s_defense == true)   ? "true" : "false";
			statement.params.submit_empire    = (s_empire == "true"    || s_empire == true)   ? "true" : "false"; 	
			
			statement.params.tool_version_major = tool_version_major;
			statement.params.tool_version_minor = tool_version_minor;
			statement.params.tool_version_revision = tool_version_revision;
									
			statement.execute();
		} catch(error) {
			alert("error at insert: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
			
		}
	},
	
	update_tool: function(id,tool_name, ogame_url, tool_url, tool_version_major, tool_version_minor, 
						  tool_version_revision, tool_user, tool_password, universe, s_galaxy,
						  s_stats, s_reports, s_allypage, s_buildings, s_research, s_fleet, s_defense, s_empire ) {
		try {
			// delete old entry of that tool (if it exists)
			var statement = null;
			
			statement = this.dbConn.createStatement('UPDATE "main"."'+this.db_tools+'" SET ' +
					'tool_name = :tool_name , ogame_url = :ogame_url , ' +
					'tool_url = :tool_url , tool_user = :tool_user , ' +
					'tool_password = :tool_password , universe = :universe , ' +
					'submit_galaxy = :submit_galaxy , submit_stats = :submit_stats , '+
					'submit_reports = :submit_reports , submit_allypage = :submit_allypage , ' +
					'submit_buildings = :submit_buildings , submit_research = :submit_research , ' +
					'submit_fleet = :submit_fleet , submit_defense = :submit_defense, ' +
					'submit_empire = :submit_empire, tool_version_major = :tool_version_major, '+
					'tool_version_minor = :tool_version_minor, tool_version_revision = :tool_version_revision '+
					'WHERE id = :id ' );
 
			
			// general data - prepared statement is providing security for SQL injection
			statement.params.tool_name        = tool_name; 
			statement.params.ogame_url        = ogame_url; 
			statement.params.tool_url         = tool_url; 
			statement.params.tool_user        = tool_user; 
			statement.params.tool_password    = tool_password;
			statement.params.universe         = universe; 
			
			// universe data
			statement.params.submit_galaxy    = (s_galaxy == "true"   || s_galaxy == true)      ? "true" : "false";
			statement.params.submit_stats     = (s_stats == "true"    || s_stats == true)       ? "true" : "false"; 
			statement.params.submit_reports   = (s_reports == "true"  || s_reports == true)     ? "true" : "false"; 
			statement.params.submit_allypage  = (s_allypage == "true" || s_allypage == true)    ? "true" : "false";
			
			// own data
			statement.params.submit_buildings = (s_buildings == "true" || s_buildings == true) ? "true" : "false";
			statement.params.submit_research  = (s_research == "true"  || s_research == true)  ? "true" : "false";
			statement.params.submit_fleet     = (s_fleet == "true"     || s_fleet == true)     ? "true" : "false"; 
			statement.params.submit_defense   = (s_defense == "true"   || s_defense == true)   ? "true" : "false"; 
			statement.params.submit_empire    = (s_empire == "true"    || s_empire == true)   ? "true" : "false"; 			
			
			statement.params.id				  = id;
			
			statement.params.tool_version_major = tool_version_major;
			statement.params.tool_version_minor = tool_version_minor;
			statement.params.tool_version_revision = tool_version_revision;
			
			statement.execute();
		} catch(error) {
			alert("error at update: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
			
		}
	},
	
	insert_translations: function(tool_ids,english_names,translations) {
		try {

			var statements = [];
			var statement = "";
			var statement2 = "";
			for (var  i=0;i < tool_ids.length;i++){
				// first, delete the old entries (just in case Ogame invents new buildings)
				
				statement = this.dbConn.createStatement('DELETE FROM "main"."'+this.db_languages+'" WHERE tool_id = '+tool_ids[i]);
				statements.push(statement);
				
				for(var j=0;j < english_names.length;j++) {
					//then insert each technique
					 statement2 = this.dbConn.createStatement('INSERT INTO "main"."'+this.db_languages+'" ' +
						'("tool_id","tech_name_english","tech_name") VALUES ' +
						"("+tool_ids[i]+",'"+english_names[j]+"','"+translations[j]+"')");  
					
					statements.push(statement2);
				}
			}
			
			//perform async request - for performance reasons!
			this.dbConn.executeAsync(statements, statements.length);
			
			return true;
		} catch(error) {
			alert("update techs error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
			return false;
		}
	},
	
	insert_ressources_names: function(tool_ids,englishnames,translations) {
		try {
			
			var statement = "";
			var statement2 = "";
			var statements = [];
			for (var  i=0;i < tool_ids.length;i++){
				
				for(var j=0;j < englishnames.length;j++) {
					statement = this.dbConn.createStatement(
						'DELETE FROM "main"."'+this.db_languages+'" '+
						'WHERE tool_id ='+tool_ids[i]+" AND tech_name_english = '"+englishnames[j]+"'");
					statements.push(statement);
					
					statement2 = this.dbConn.createStatement(
						'INSERT INTO "main"."'+this.db_languages+'" ' +
						'("tool_id","tech_name_english","tech_name") VALUES ' +
						"("+tool_ids[i]+",'"+englishnames[j]+"','"+translations[j]+"')");  
					statements.push(statement2);
				}
			}
			
			this.dbConn.executeAsync(statements, statements.length);
			return true;
		} catch(error) {
			alert("update techs error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
			return false;
		}
	},
	
	get_translation: function(tool_id,word) {
		try {
			var statement = "";
			statement = this.dbConn.createStatement('SELECT * FROM "main"."'+this.db_languages+'" WHERE tool_id = :tool_id AND tech_name = :tech_name');
			statement.params.tool_id = tool_id;
			statement.params.tech_name = word;
			
			while(statement.executeStep()){
				var translation = statement.row.tech_name_english;
				statement.reset();
				return translation;		
			}
			
			var confirmation = confirm(eu.galaxytool.GTPlugin_general.getLocString("error.missing_techs_prefix")+word
								+eu.galaxytool.GTPlugin_general.getLocString("error.missing_techs_suffix")+"\n\n"+
								eu.galaxytool.GTPlugin_general.getLocString("error.missing_techs_confirmation"));
								
			if(confirmation) {
				var loc = eu.galaxytool.GTPlugin_general.Messagedoc.location.href;
				var session = loc.match(/session\=(\w+)/)[1];
				loc = loc.substring(0,loc.indexOf('?'));
				loc = loc+'?page=globalTechtree&session='+session;
				var new_win = window.open(loc,'techinfo','scrollbars=yes,menubar=auto,top=0,left=0,toolbar=no,width=680,height=600,resizable=yes');
				new_win.focus(); 
			}
			
			return "Unknown entry";
		} catch(error) {
			alert("get translations error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
		}
	},
	
	install: function() {
		// install latest DB table schema
		try {
			
			var tool_db_exists = this.dbConn.tableExists(this.db_tools);
			if (tool_db_exists == true) {
				return;
			}
			
			var statement = '' +
					'CREATE TABLE "'+this.db_tools+'" (' +
					'"id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL , ' +
					'"tool_name" VARCHAR NOT NULL , ' +
					'"ogame_url" VARCHAR NOT NULL , ' +
					'"tool_url" VARCHAR NOT NULL , ' +
					'"tool_user" VARCHAR NOT NULL , ' +
					'"tool_password" VARCHAR NOT NULL, ' +
					'"universe" VARCHAR NOT NULL, ' +
					'"submit_galaxy" VARCHAR NOT NULL, ' +
					'"submit_stats" VARCHAR NOT NULL, ' +
					'"submit_reports" VARCHAR NOT NULL, ' +
					'"submit_allypage" VARCHAR NOT NULL, ' +
					'"submit_buildings" VARCHAR NOT NULL, ' +
					'"submit_research" VARCHAR NOT NULL, ' +
					'"submit_fleet" VARCHAR NOT NULL, ' +
					'"submit_defense" VARCHAR NOT NULL, '+
					'"submit_empire" VARCHAR NOT NULL, '+
					'"tool_version_major" INTEGER NOT NULL DEFAULT 0, '+
					'"tool_version_minor" INTEGER NOT NULL DEFAULT 0, '+
					'"tool_version_revision" INTEGER NOT NULL DEFAULT 0 )';
			
			this.dbConn.executeSimpleSQL(statement);
					
			var languages_db_exists = this.dbConn.tableExists(this.db_languages);
			if (languages_db_exists == true) {
				return;
			}		
			
			var statement2 = '' + 
					'CREATE TABLE "'+this.db_languages+'" (' +
					'"tool_id" INTEGER NOT NULL , ' +
					'"tech_name_english" VARCHAR NOT NULL , ' +
					'"tech_name" VARCHAR NOT NULL )';
					
			this.dbConn.executeSimpleSQL(statement2);
			
		} catch(error) {
			alert("install error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
		}		  
	},
	
	install_update_2_4: function() {
		try {
			var languages_db_exists = this.dbConn.tableExists(this.db_languages);
			if (!languages_db_exists) {			
				var statement = '' + 
						'CREATE TABLE "'+this.db_languages+'" (' +
						'"tool_id" INTEGER NOT NULL , ' +
						'"tech_name_english" VARCHAR NOT NULL , ' +
						'"tech_name" VARCHAR NOT NULL )';
							
				this.dbConn.executeSimpleSQL(statement);
			}
			
			// it is not possible to add more than one column at the same time with SQLITE
			if(!this.column_exists(this.db_tools,"submit_empire")) {
				var statement5 = '' +
						'ALTER TABLE "'+this.db_tools+'" '+
						'ADD COLUMN "submit_empire" VARCHAR NOT NULL DEFAULT true';
				this.dbConn.executeSimpleSQL(statement5);
			}
			
			if(!this.column_exists(this.db_tools,"tool_version_major")) {
				var statement2 = '' +
						'ALTER TABLE "'+this.db_tools+'" '+
						'ADD COLUMN "tool_version_major" INTEGER NOT NULL DEFAULT 0';
				this.dbConn.executeSimpleSQL(statement2);
			}
			
			if(!this.column_exists(this.db_tools,"tool_version_minor")) {
				var statement3 = '' +
						'ALTER TABLE "'+this.db_tools+'" '+
						'ADD COLUMN "tool_version_minor" INTEGER NOT NULL DEFAULT 0';
				this.dbConn.executeSimpleSQL(statement3);	
			}
			
			if(!this.column_exists(this.db_tools,"tool_version_revision")) {
				var statement4 = '' +
						'ALTER TABLE "'+this.db_tools+'" '+
						'ADD COLUMN "tool_version_revision" INTEGER NOT NULL DEFAULT 0';
				this.dbConn.executeSimpleSQL(statement4);
			}
			
			
		} catch(error) {
			alert("install update 2.4 error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
		}	
	},
	
	column_exists: function(table,column){
		try {
			var statement = '' + 
							'SELECT '+column+' FROM "main"."'+table+'"';
			statement = this.dbConn.createStatement(statement);
														
			while (statement.executeStep()) {	
				statement.reset();	
				return true;
			}
			
			return false;
			
		} catch(column_does_not_exist) {
			return false;
		}					
	},
		
	tool_exists: function(id) {
		try {
			var sqlquery = 'SELECT * FROM "main"."'+this.db_tools+'" WHERE id = :id';
			var statement = this.dbConn.createStatement(sqlquery);
			statement.params.id = id;
			
			while (statement.executeStep()) {
				statement.reset();
				return true;
			}
			
			return false;
			
		} catch(error) {
			alert("tool exists error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
			return false;
		}
	},
	
	delete_tool: function(id) {
		try {
			if (id != null) {
				// Tool was loaded from SQLite
				var sqlquery = 'DELETE FROM "main"."'+this.db_tools+'" WHERE id = :id';
				var statement = this.dbConn.createStatement(sqlquery);
				statement.params.id = id;
				statement.execute();
				
				var sqlquery2 = 'DELETE FROM "main"."'+this.db_languages+'" WHERE tool_id = :id';
				var statement2 = this.dbConn.createStatement(sqlquery2);
				statement2.params.id = id;
				statement2.execute();
			}
			
		} catch(error) {
			alert("delete tool error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
		}		
	},
	
	read_tools: function() {
		try {
			var return_value = new Array();
			var statement    = "";
		
			statement = this.dbConn.createStatement('SELECT * FROM "main"."'+this.db_tools+'"');
			
   			while (statement.executeStep()) {  
   				var array_index = return_value.length;
				return_value[array_index] = new Object();
				return_value[array_index]["id"]            		= statement.row.id;
				return_value[array_index]["deleted"]       		= false;
				return_value[array_index]["updated"]       		= false;
				return_value[array_index]["name"]          		= statement.row.tool_name;
				return_value[array_index]["ogame_url"]     		= statement.row.ogame_url;
				return_value[array_index]["tool_url"]      		= statement.row.tool_url;
				return_value[array_index]["tool_version_major"] = statement.row.tool_version_major;
				return_value[array_index]["tool_version_minor"] = statement.row.tool_version_minor;
				return_value[array_index]["tool_version_revision"] = statement.row.tool_version_revision;
				return_value[array_index]["tool_user"]     		= statement.row.tool_user;
				return_value[array_index]["tool_password"] 		= statement.row.tool_password;
				return_value[array_index]["universe"]      		= statement.row.universe;
	
				// universe data checkboxes
				return_value[array_index]["submit_galaxy"]   = statement.row.submit_galaxy;
				return_value[array_index]["submit_stats"]    = statement.row.submit_stats;
				return_value[array_index]["submit_reports"]  = statement.row.submit_reports;
				return_value[array_index]["submit_allypage"] = statement.row.submit_allypage;
				
				// own data checkboxes
				return_value[array_index]["submit_buildings"] = statement.row.submit_buildings;
				return_value[array_index]["submit_research"]  = statement.row.submit_research;
				return_value[array_index]["submit_fleet"]     = statement.row.submit_fleet;
				return_value[array_index]["submit_defense"]   = statement.row.submit_defense;
				return_value[array_index]["submit_empire"]   = statement.row.submit_empire;
   			}  
   			
   			return return_value;
			
		} catch(error) {
			alert("read tools error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
		}		
	},
	
	read_tool_ids_for_ogame_url: function(universe_url) {
		var ids = new Array();
		var statement = "";
		
		try {
			statement = this.dbConn.createStatement('SELECT * FROM "main"."'+this.db_tools+'" WHERE \''+universe_url+'\' LIKE \'%\' || ogame_url || \'%\'');
			
			while (statement.executeStep()) {
				ids.push(statement.row.id);
			}
		
			return ids;
			
		} catch (error) {
			alert("read tools for ogame url error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
		}
	},
	
	read_tools_for_ogame_url: function(universe_url) {
		try {
			var return_value = new Array();
			var statement    = "";
		
			statement = this.dbConn.createStatement('SELECT * FROM "main"."'+this.db_tools+'" WHERE \''+universe_url+'\' LIKE \'%\' || ogame_url || \'%\'');
			
   			while (statement.executeStep()) {  
   				var array_index = return_value.length;
				return_value[array_index] = new Object();
				return_value[array_index]["id"]            		= statement.row.id;
				return_value[array_index]["deleted"]      		= false;
				return_value[array_index]["updated"]       		= false;
				return_value[array_index]["name"]          		= statement.row.tool_name;
				return_value[array_index]["ogame_url"]     		= statement.row.ogame_url;
				return_value[array_index]["tool_url"]      		= statement.row.tool_url;
				return_value[array_index]["tool_version_major"] = statement.row.tool_version_major;
				return_value[array_index]["tool_version_minor"] = statement.row.tool_version_minor;
				return_value[array_index]["tool_version_revision"] = statement.row.tool_version_revision;
				return_value[array_index]["tool_user"]     		= statement.row.tool_user;
				return_value[array_index]["tool_password"] 		= statement.row.tool_password;
				return_value[array_index]["universe"]      		= statement.row.universe;
	
				// universe data checkboxes
				return_value[array_index]["submit_galaxy"]   = (statement.row.submit_galaxy == "true") ? true : false;
				return_value[array_index]["submit_stats"]    = (statement.row.submit_stats == "true") ? true : false;
				return_value[array_index]["submit_reports"]  = (statement.row.submit_reports == "true") ? true : false;
				return_value[array_index]["submit_allypage"] = (statement.row.submit_allypage == "true") ? true : false;
				
				// own data checkboxes
				return_value[array_index]["submit_buildings"] = (statement.row.submit_buildings == "true") ? true : false;
				return_value[array_index]["submit_research"]  = (statement.row.submit_research == "true") ? true : false;
				return_value[array_index]["submit_fleet"]     = (statement.row.submit_fleet == "true") ? true : false;
				return_value[array_index]["submit_defense"]   = (statement.row.submit_defense == "true") ? true : false;
				return_value[array_index]["submit_empire"]   =  (statement.row.submit_empire == "true") ? true : false;;
   			}  
   			
   			return return_value;
			
		} catch(error) {
			alert("read tools for ogame url error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
		}		
	},

	target_tool_exists: function(universe_url,parameter) {
		try {
			var statement    = "";
			
			switch(parameter) {
				case "galaxy"   : parameter = "submit_galaxy"; break;
				case "stats"    : parameter = "submit_stats"; break;
				case "reports"  : parameter = "submit_reports"; break;
				case "allypage" : parameter = "submit_allypage"; break;
				case "buildings": parameter = "submit_buildings"; break;
				case "research" : parameter = "submit_research"; break;
				case "fleet"    : parameter = "submit_fleet"; break;
				case "defense"  : parameter = "submit_defense"; break;
				case "empire"  : parameter = "submit_empire"; break;
				default: parameter = "submit_galaxy";
			}
			
			statement = this.dbConn.createStatement('SELECT * FROM "main"."'+this.db_tools+'" WHERE \''+universe_url+'\' LIKE \'%\' || ogame_url || \'%\' AND '+parameter+'=\'true\'');
			
			
   			while (statement.executeStep()) {  
   				//always reset statement when last execution returned true, so the table is not locked anymore
   				statement.reset();
   				return true;
   			}  
   			
   			return false;
			
		} catch(error) {
			alert("read tools for ogame url error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
			return false;
		}		
	},

	get_number_of_tools: function() {
		try {
			var return_value = 0;
			var statement    = "";
		
			statement = this.dbConn.createStatement('SELECT * FROM "main"."'+this.db_tools+'"');
			
   			while (statement.executeStep()) {  
   				return_value++;
   			}  
   			
   			return return_value;
			
		} catch(error) {
			alert("get number of tools error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
		}		
	},
	
	update_universe_for_ogame_url: function(universe_url,universe_name) {
		try {
			var statement    = "";
			var query = 'UPDATE "main"."'+this.db_tools+'" SET universe = :universe WHERE \''+universe_url+'\' LIKE \'%\' || ogame_url || \'%\'';
			statement = this.dbConn.createStatement('UPDATE "main"."'+this.db_tools+'" SET universe = :universe WHERE \''+universe_url+'\' LIKE \'%\' || ogame_url || \'%\'');
			statement.params.universe = universe_name; 
			statement.execute();
			
		} catch(error) {
			alert("update universe for ogame url error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString+"\nQuery: "+query);
		}		
	},
	
		
	update_galaxytool_version: function(tool_url,tool_version_major,tool_version_minor,tool_version_revision) {
		try {
			var statement    = "";
			statement = this.dbConn.createStatement('UPDATE "main"."'+this.db_tools+'" '+
													'SET tool_version_major = :tool_version_major, '+
													'tool_version_minor = :tool_version_minor, '+
													'tool_version_revision = :tool_version_revision '+
													'WHERE tool_url = :tool_url');
			
			statement.params.tool_version_major = tool_version_major;
			statement.params.tool_version_minor = tool_version_minor;
			statement.params.tool_version_revision = tool_version_revision;
			
			statement.params.tool_url = tool_url;
			
			statement.execute();
		} catch(error) {
			alert("update galaxytool version error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString+"\nQuery: "+query);
		}
	},
	
	copy_pref_data_to_db: function() {
		try {

			var Prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			
			// Tool 1-5
			for (var i = 1; i < 6; i++) {
				if (Prefs.getCharPref("gtplugin.settings.url"+i) != "") {
					eu.galaxytool.GTPlugin_storage.insert_tool(
						i, // ID
						"Tool"+i, // Tool Name
						Prefs.getCharPref("gtplugin.settings.ogameurl"+i), // Ogame URL
						Prefs.getCharPref("gtplugin.settings.url"+i), // tool url
						0, // galaxytool version major
						0, // galaxytool version minor
						0, // galaxytool version revision
						Prefs.getCharPref("gtplugin.settings.username"+i), // tool user
						Prefs.getCharPref("gtplugin.settings.password"+i), // tool password
						Prefs.getCharPref("gtplugin.settings.ogameuni"+i), // universe
						Prefs.getBoolPref("gtplugin.settings.submib_galaxy"), // submit galaxy
						Prefs.getBoolPref("gtplugin.settings.submib_stats"),// submit stats
						Prefs.getBoolPref("gtplugin.settings.submib_reports"),// submit reports
						Prefs.getBoolPref("gtplugin.settings.submib_allypage"),// submit allypage
						Prefs.getBoolPref("gtplugin.settings.submib_buildings"),// submit buildings
						Prefs.getBoolPref("gtplugin.settings.submib_research"),// submit research
						Prefs.getBoolPref("gtplugin.settings.submib_fleet"),// submit fleet
						Prefs.getBoolPref("gtplugin.settings.submib_defense"),// submit defense
						true //submit empire
					);
				}
			}
			
		} catch(error) {
			// alert("copy pref data to db error: "+error+"\n\nSQL error details: "+this.dbConn.lastErrorString);
			// no error! If no prefs exist, this exception will be catched instead
		}		
	},
	
	close: function() {
	    if (this.dbConn != null) {
	    	try {
				this.dbConn.close();
			} catch (e) {
	        	this.dbConn = null;
	      	}
	    }		
	}
 
 
}  