if(!eu) var eu={};
if(!eu.galaxytool) eu.galaxytool={};
if(!eu.galaxytool.GTPlugin_stats) eu.galaxytool.GTPlugin_stats={};

eu.galaxytool.GTPlugin_stats = {
	
	selectedRanks: -1,
	selectedTyp: -1,
	selectedWer: -1,
	Messagedoc: null,
	
	getStatsWho: function(docroot) {
	    // get information about what was selected - player=0 or ally=1
	    try {
	        var stats_who = docroot.getElementById("who").value;
	        if (stats_who == "player") {
		        return 0; // players are selected by default
	        } else {
	        	return 1;
	        }
	    } catch(e) {
	        // nothing to do
	    }
	    return -1;
	},
	
	
	getStatsTyp: function(docroot) {
	    // get information about what was selected - points=0 or fleet=1 or research=2
	    try {
	    	var stats_type = docroot.getElementById("points").getAttributeNode("class").value;
	    	if (stats_type == "active") {
	    		return 0;
	    	}
	    	
	    	var stats_type = docroot.getElementById("fleet").getAttributeNode("class").value;
	    	if (stats_type == "active") {
	    		return 1;
	    	}
	    	
	    	var stats_type = docroot.getElementById("research").getAttributeNode("class").value;
	    	if (stats_type == "active") {
	    		return 2;
	    	}
	    	
	    	return -1;
	
	    } catch(e) {
	        // nothing to do
	    }
	    return -1;
	},

	getStatsWhich: function(docroot) {
	    // get information about what ranks were selected
	    try {
	        return docroot.getElementById("start_at").value;
	    } catch(e) {
	        // nothing to do
	    }
	    return -1;
	},
	

	getStatsText: function(docroot) {
	    var element;
	    var found = 0;
	    var width = 0;
	    var rows;
	    
	    var current_row;
	    var line_cells;
	    var rank;
	    var playername;
	    var home_galaxy;
	    var home_system;
	    var home_planet
	    var allyname;
	    var allyid;
	    var playerid;
	    var ally_xml = "";
	    var player_xml = "";
	    
	   	var statstype;
	        
	        switch(this.getStatsTyp(docroot)) {
	        	case 0: statstype = "score";
	        			break;
	        	case 1: statstype = "fleet";
	        			break;
	        	case 2: statstype = "research";
	        			break;
	        }
	        
		if(this.selectedWer == 0) { // Players        
	        
	        try {
	        	
		        rows = docroot.getElementById("ranks").rows;
		        	
		        var ranks = new Array(rows.length-1);
		        var players = new Array(rows.length-1);
		        var pIds = new Array(rows.length-1);
		        var alliances = new Array(rows.length-1);
		        var ally_ids = new Array(rows.length-1);
		        var points = new Array(rows.length-1);
		        var home_galaxies = new Array(rows.length-1);
		        var home_systems = new Array(rows.length-1);
		        var home_planets = new Array(rows.length-1);
	
			
				var players_with_playerid_0 = 0;
				
				for (var i = 0; i < rows.length - 1; i++ ) {
					line_cells = rows[i+1].cells; // ignore row[0] (table head)
					
					// Ogame v1.2 has 5 cells instead of 4, but only in playerstats
					// besides the rank can be read directly
					
						// first cell contains rank
						rank = line_cells[0].innerHTML;
						rank = parseInt(rank);
						ranks[i] = rank;
						
						// third cell (since Ogame v1.2, only playerstats) contains allyname (first link) and playername (second link)
						playername = "";
						allyname = "";
						
						try {
							// get second link
							playername = eu.galaxytool.GTPlugin_general.trimString(line_cells[2].getElementsByTagName("a")[1].innerHTML);
							// Col: remove |
							playername = playername.replace(/\|/g, "");
							
							//index.php?page=galaxy&session=1ba028eddf35&galaxy=2&system=40&position=6
							var tmp = line_cells[2].getElementsByTagName("a")[1].getAttribute("href");
														
							home_galaxy = tmp.match(/galaxy\=(\d+)/)[1];
							home_system = tmp.match(/system\=(\d+)/)[1];
							home_planet = tmp.match(/position\=(\d+)/)[1];

							// if no exception was raised we also have an alliance name at link 1
							allyname = eu.galaxytool.GTPlugin_general.trimString(line_cells[2].getElementsByTagName("a")[0].innerHTML);
							
							// remove first [ and last ], anything else belongs to the allyname
							allyname = allyname.replace(/^\[/,"").replace(/\]$/,"");
							
							tmp = line_cells[2].getElementsByTagName("a")[0].getAttribute("href");
							
							try {
								allyid = tmp.match(/allyid\=(\d+)/)[1];
							} catch(own_ally){
								//TODO: maybe, there will be the possibility to get the own allyid somewhere else, but atm, it is nowhere!
								allyid = -1;
							}
							
							
							
						} catch(no_ally) {
							// player has no ally - first link is playername
							playername = eu.galaxytool.GTPlugin_general.trimString(line_cells[2].getElementsByTagName("a")[0].innerHTML);				

							
							var tmp = line_cells[2].getElementsByTagName("a")[0].getAttribute("href");
							
							
							home_galaxy = tmp.match(/galaxy\=(\d+)/)[1];
							home_system = tmp.match(/system\=(\d+)/)[1];
							home_planet = tmp.match(/position\=(\d+)/)[1];
							
							//no ally
							allyid = 0;
						}
						
						players[i] = playername;
						alliances[i] = allyname;
						home_galaxies[i] = home_galaxy;
						home_systems[i] = home_system;
						home_planets[i] = home_planet;
						ally_ids[i] = allyid;
						
						//after collecting the infos for xml - delete the |, which can't be handeled in old engine...
						// Col: remove |
						allyname = allyname.replace(/\|/g,"");
						
						// Col: remove |
						playername = playername.replace(/\|/g, "");
						
						
						// fourth cell (since Ogame v1.2, only playerstats) contains write message including playerid
						try {
							// &to=101072&
							playerid = line_cells[3].getElementsByTagName("a")[0].getAttributeNode("href").value.match(/to\=(\d+)/)[1];
						} catch(ow_payer) {
							// in case we found ourselve
							playerid = 0;
							players_with_playerid_0++;
						}
						pIds[i] = playerid;
						
						// fifth message (since Ogame v1.2, only playerstats) contains score
						// OGame bug: sometimes there are negative points
						points[i] = line_cells[4].innerHTML;
						if (points[i].indexOf('-') > -1) {
							points[i] = 0
						} else {
							points[i] = parseInt(points[i].replace(/[^0-9]/g,""));
						}
						
					// check consistency of data
					if ((playername == "") || 
					    (playerid == 0 && players_with_playerid_0 > 1) ||
					    (points[i] == "NaN")) {
						
						// inconsistent data
						eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+1 , 0, "inconsistent data after parsing page: \n"
						+ "playername: " + playername  + "\n"
						+ "playerid: " + playerid + "\n"
						+ "number of players without playerid: " + players_with_playerid_0 + "\n"
						+ "points: " + points + "\n");
						
						return [false,false];
					}
			
				}
				
		        var data = "";
		        data += "&ranks=" + ranks.join("|");
		        data += "&players=" + players.join("|");
		        data += "&pIds=" + pIds.join("|");
		        data += "&alliances=" + alliances.join("|");
		        data += "&points=" + points.join("|");
		        
		        player_xml += '	<stats_header type="'+statstype+'"/>'+'\n';
		        
		        for(var i = 0; i < ranks.length; i++) {
		        	if (alliances[i] == "") {
		        		player_xml += '	<player rank="'+ranks[i]+'" playername="'+players[i]+
		        					  '" playerid="'+pIds[i]+'" galaxy="'+home_galaxies[i]+
		        					  '" system="'+home_systems[i]+'" planet="'+home_planets[i]+
		        					  '" score="'+points[i]+'"/>'+'\n';
		        	}  else {		        	
		        	player_xml +=   '	<player rank="'+ranks[i]+'" playername="'+players[i]+
		        					'" playerid="'+pIds[i]+'" galaxy="'+home_galaxies[i]+
		        					'" system="'+home_systems[i]+'" planet="'+home_planets[i]+
		        					'" allyname="'+alliances[i];
		        		if(ally_ids[i] != -1) {
		        			//own alliance
	        				player_xml += '" allyid="'+ally_ids[i];
		        	}
		        	player_xml += '" score="'+points[i]+'"/>'+'\n';
		        	}
		        }
		        
		        return [data,player_xml]
		        
			} catch(e) {
				eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+1 , 0, "Unexpected error: "+e+" at rank: "+rank);
				return [false,false];
			}
		} else {
			try {
			// alliances
	        rows = docroot.getElementById("ranks").rows;
	       
	        var ranks = new Array(rows.length-1);
	        var alliances = new Array(rows.length-1);
	        var members = new Array(rows.length-1);
	        var points = new Array(rows.length-1);
	        var alliance_ids = new Array(rows.length-1);

	        ally_xml += '	<stats_header type="'+statstype+'"/>'+'\n';
			
			for (var i = 0; i < rows.length-1; i++ ) {
				line_cells = rows[i+1].cells;
				
				// cell one for rank
				var tmp = line_cells[0].innerHTML;
				ranks[i] = parseInt(tmp.substring(0,tmp.indexOf("&nbsp;")).replace(/[^0-9]/g,""));
				
				// cell two for name
				alliance = eu.galaxytool.GTPlugin_general.trimString(line_cells[1].getElementsByTagName("a")[0].innerHTML);
				
				// ogame deletes alliances at 1:15
				// before that time, there are sometimes alliances without name
				// this would make the toolbar recognize the whole page as inconsistent
				if (alliance == "") {
				alliance = "EmptyAlliance";
				}
				
				//collect information for xml, before deleting |
				alliances[i] = alliance;
				
				// Col: remove |
				alliance = alliance.replace(/\|/g, "");
				
				//after deleting the | check if the alliance is empty again
				if (alliance == "") {
				alliance = "EmptyAlliance";
				}
				
				try {
				alliance_ids[i] = line_cells[1].getElementsByTagName("a")[0].getAttribute("href").match(/allyid\=(\d+)/)[1];
				} catch(own_ally_or_empty_ally) {
					//unknown in v1.2.5 of OGame
					alliance_ids[i] = 0;
				}
				
									
				// cell four for points
				points[i] = parseInt(line_cells[3].innerHTML.replace(/[^0-9]/g,""));			
				
				// cell five for members
				members[i] = line_cells[4].innerHTML.replace(/\.|\,/g,"").match(/\s*(\d+)\s\((\d+)\)\s*/)[1];			
	
					// check consistency of data
					if ((ranks[i] == "NaN") || 
					    (alliances[i] == "") ||
					    (points[i] == "NaN") ||
					    (members[i] == "")) {
						
						// inconsistent data
						eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+1 , 0, "inconsistent data after parsing page: \n"
						+ "rank: " + ranks[i]  + "\n"
						+ "alliance: " + alliances[i] + "\n"
						+ "points: " + points[i] + "\n"
						+ "member: " + members[i] + "\n");
						
						return [false,false];
					}
			}
			var num_allies = 0;
			 for(var i = 0; i < ranks.length; i++) {
			 	if(alliances[i] != "EmptyAlliance") {
			 		ally_xml += '	<ally rank="'+ranks[i]+'" allyname="'+alliances[i];
			 		if(alliance_ids[i] != 0) {
			 			//own ally
			 			ally_xml += '" allyid="'+alliance_ids[i];
			 		}
			 		ally_xml += '" member="'+members[i]+'" score="'+points[i]+'"/>'+'\n';
			 		num_allies++;
			 	}
			 }
			 
			//there was no ally 
			if(num_allies == 0) {
				return [false,false]
			}
				
	        var data = "";
	        data += "&ranks=" + ranks.join("|");
	        data += "&alliances=" + alliances.join("|");
	        data += "&members=" + members.join("|");
	        data += "&points=" + points.join("|");	
	        
	        return [data,ally_xml]
	
			} catch(e) {
				eu.galaxytool.GTPlugin_general.set_status(docroot, "galaxyplugin"+1 , 0, "Unexpected error: "+e);
				return [false,false];
			}
			
		}
	
	    
	},

	submit_statsdata: function(e) {
		try {
			var id = e.relatedNode.getAttributeNode("id").value;
			if (id != "statisticsContent") {
				return;
			}
			var classname = e.target.getAttributeNode("class").value;
			if (classname != "content") {
				return;
			}
			
			doc = this.Messagedoc;
			try {
				eu.galaxytool.GTPlugin_general.clear_status(doc);
			} catch(e) {
				alert("error: "+e);
			}
	       	// GTPlugin_create_status_tab(doc);
	       	eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 0, eu.galaxytool.GTPlugin_general.getLocString("statsfound"));
	        eu.galaxytool.GTPlugin_general.selectedTyp = this.selectedTyp = this.getStatsTyp(doc);
	        if (this.selectedTyp == -1) return; // no content loaded yet
			eu.galaxytool.GTPlugin_general.selectedWer = this.selectedWer = this.getStatsWho(doc);
			if (this.selectedWer == -1) return; // no content loaded yet
			this.selectedRanks = this.getStatsWhich(doc);
			if (this.selectedRanks == -1) return; // no content loaded yet
	
			this.selectedRanks = this.selectedRanks + "-" + (parseInt(this.selectedRanks) + 99);
			eu.galaxytool.GTPlugin_general.selectedRanks = this.selectedRanks;
			// check if the table was resorted somehow
			if (doc.getElementById('sort_per_member').value == 0) {
				var text,text_xml;
				[text,text_xml] = this.getStatsText(doc);
				
				//alert(text_xml);
				
				if (text != false) {
					GTPlugin_result = eu.galaxytool.GTPlugin_general.send(doc,"stats",text,text_xml,doc.location.href)
				}
			} else {
				// ignore the content - table was resorted
			    eu.galaxytool.GTPlugin_general.set_status(doc, "galaxyplugin"+1 , 3, eu.galaxytool.GTPlugin_general.getLocString("error.statssort"));
			}
		} catch(no_error) {
			// nothing to do here
			return;
		}
	}
	
}